var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input } from '@angular/core';
var BaseComponent = /** @class */ (function () {
    function BaseComponent() {
        this.layoutContainerNode = null;
        this._subscriptions = new Array();
    }
    BaseComponent.prototype.makeFullHeight = function (el) {
        var top = el.nativeElement.getBoundingClientRect().top;
        if (!this.layoutContainerNode) {
            var body = document.body;
            var html = document.documentElement;
            var bodyHeight = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);
            el.nativeElement.style.height = bodyHeight - top + "px";
        }
        else {
            var height = this.layoutContainerNode.getBoundingClientRect().height;
            var outterTop = this.layoutContainerNode.getBoundingClientRect().top;
            el.nativeElement.style.height = height - top + outterTop + "px";
        }
    };
    BaseComponent.prototype.on = function (observable, next) {
        this._subscriptions.push(observable.subscribe(next));
    };
    BaseComponent.prototype.onMany = function (observables, next) {
        for (var _i = 0, observables_1 = observables; _i < observables_1.length; _i++) {
            var observable = observables_1[_i];
            this._subscriptions.push(observable.subscribe(next));
        }
    };
    BaseComponent.prototype.ngOnDestroy = function () {
        this._subscriptions.forEach(function (s) { return s && s.unsubscribe(); });
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseComponent.prototype, "layoutContainerNode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseComponent.prototype, "shadowedAttributes", void 0);
    return BaseComponent;
}());
export { BaseComponent };
//# sourceMappingURL=base.component.js.map