import { OnDestroy } from '@angular/core';
import { BaseComponent } from './base.component';
import { RemoteEventHubService } from '../../services/remote-event-hub.service';
export declare abstract class RemoteEventBaseComponent extends BaseComponent implements OnDestroy {
    private _hubService;
    private _remoteEventHandlers;
    constructor(_hubService: RemoteEventHubService);
    /**
     * Wires up a callback to be invoked when a invocation request is received from the remote server hub.
     * @param eventName The name of the hub event to register the callback for.
     * @param callback The callback to be invoked.
     */
    protected remoteOn(eventName: string, callback: Function): void;
    protected remoteOnMany(eventNames: string[], callback: Function): void;
    ngOnDestroy(): void;
}
