var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { BaseComponent } from './base.component';
var RemoteEventBaseComponent = /** @class */ (function (_super) {
    __extends(RemoteEventBaseComponent, _super);
    function RemoteEventBaseComponent(_hubService) {
        var _this = _super.call(this) || this;
        _this._hubService = _hubService;
        _this._remoteEventHandlers = [];
        return _this;
    }
    /**
     * Wires up a callback to be invoked when a invocation request is received from the remote server hub.
     * @param eventName The name of the hub event to register the callback for.
     * @param callback The callback to be invoked.
     */
    RemoteEventBaseComponent.prototype.remoteOn = function (eventName, callback) {
        var callbackIdentity = { eventName: eventName, callback: callback };
        this._remoteEventHandlers.push(callbackIdentity);
        this._hubService.on(eventName, callback, callbackIdentity);
    };
    RemoteEventBaseComponent.prototype.remoteOnMany = function (eventNames, callback) {
        var _this = this;
        eventNames.forEach(function (eventName) { return _this.remoteOn(eventName, callback); });
    };
    RemoteEventBaseComponent.prototype.ngOnDestroy = function () {
        var _this = this;
        _super.prototype.ngOnDestroy.call(this);
        this._remoteEventHandlers.forEach(function (callbackIdentity) {
            return _this._hubService.off(callbackIdentity.eventName, callbackIdentity.callback, callbackIdentity);
        });
    };
    return RemoteEventBaseComponent;
}(BaseComponent));
export { RemoteEventBaseComponent };
//# sourceMappingURL=remote-event-base.component.js.map