var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { EventEmitter, Input, Output } from '@angular/core';
import * as _isEqual from 'lodash-es/isEqual';
import cloneDeep from 'lodash-es/cloneDeep';
import { debounceTime } from 'rxjs/operators';
import { ExtendedFormGroup } from '../../forms';
import { BaseContainer } from '../base-container/base-container.component';
/**
 * Represents the base component for all form component.
 * It provides getter and setter for common attributes.
 */
var BaseControl = /** @class */ (function (_super) {
    __extends(BaseControl, _super);
    function BaseControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.postBack = false;
        _this.debounceTime = 100;
        _this.focus = false;
        _this.emitEventAfterViewInit = false;
        _this.isCultureSpecific = false;
        _this.onChange = new EventEmitter();
        _this.onAfterViewInit = new EventEmitter();
        _this._onPostBackRequest = new EventEmitter();
        return _this;
    }
    BaseControl.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.emitEventAfterViewInit) {
            this.onAfterViewInit.emit(cloneDeep(this.value));
        }
        if (this.postBack) {
            this.on(this._onPostBackRequest.pipe(debounceTime(this.debounceTime || 100)), function () {
                _this.form.fireOnPostback();
            });
        }
    };
    Object.defineProperty(BaseControl.prototype, "formControl", {
        get: function () {
            return this.form.controls[this.name];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseControl.prototype, "isValid", {
        get: function () { return this.form.controls[this.name].valid; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseControl.prototype, "backupValue", {
        get: function () {
            return this.form.controls[this.name] ? cloneDeep(this.form.controls[this.name]['backupValue']) : null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Sync data from view to form model, as well as mark a field as dirty.
     * @param value the field value got from view's input
     */
    BaseControl.prototype.valueChange = function (value) {
        var _this = this;
        this.form && this.form.controls[this.name] && this.form.setControlValue(this.name, cloneDeep(value), function (newValue, oldValue) { return _this.isEqual(newValue, oldValue); });
        this.onChange.emit(cloneDeep(value));
        this._onPostBackRequest.emit(value);
    };
    /**
     * The default implementation of value comparision.
     * This function is called to determine if the value is changed, to mark the field
     * as dirty or pristine.
     * Implementation can override this, to do custom comparision. For example, to treat null
     * and empty string equally.
     * @param newValue new value.
     * @param oldValue old value.
     */
    BaseControl.prototype.isEqual = function (newValue, oldValue) {
        return _isEqual.default(newValue, oldValue);
    };
    __decorate([
        Input(),
        __metadata("design:type", ExtendedFormGroup)
    ], BaseControl.prototype, "form", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], BaseControl.prototype, "label", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseControl.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseControl.prototype, "postBack", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], BaseControl.prototype, "debounceTime", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BaseControl.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseControl.prototype, "isCultureSpecific", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BaseControl.prototype, "onChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BaseControl.prototype, "onAfterViewInit", void 0);
    return BaseControl;
}(BaseContainer));
export { BaseControl };
//# sourceMappingURL=base-control.component.js.map