var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ElementRef, EventEmitter, Input, Output, ViewChild } from '@angular/core';
var BaseDialog = /** @class */ (function () {
    function BaseDialog() {
        this.closeOnEscape = true;
        this.closeOnOutsideClick = true;
        this.submitOnEnter = false;
        this.cssClass = '';
        this.minWidth = 300;
        this.minHeight = 150;
        this.resizing = new EventEmitter();
        this.resizeEnd = new EventEmitter();
        this.style = {};
        this._oldHeight = 0;
        this._oldWidth = 0;
    }
    BaseDialog.prototype.preventClosing = function (event) {
        event.stopPropagation();
    };
    BaseDialog.prototype.focus = function () {
        this._focusableElement.nativeElement.focus();
    };
    BaseDialog.prototype.onResizing = function (event) {
        var newHeight = this.minHeight ? (event.rectangle.height > this.minHeight ? event.rectangle.height : this.minHeight) : event.rectangle.height;
        var newWidth = this.minWidth ? (event.rectangle.width > this.minWidth ? event.rectangle.width : this.minWidth) : event.rectangle.width;
        this.style = {
            position: 'fixed',
            left: event.rectangle.left + "px",
            top: event.rectangle.top + "px",
            width: newWidth + "px",
            height: newHeight + "px"
        };
        if (event.rectangle.height !== this._oldHeight || event.rectangle.width !== this._oldWidth) {
            this.resizing.emit({ height: event.rectangle.height, width: event.rectangle.width });
        }
        this._oldHeight = event.rectangle.height;
        this._oldWidth = event.rectangle.width;
    };
    BaseDialog.prototype.onResizeEnd = function (event) {
        this.resizeEnd.emit({ height: event.rectangle.height });
    };
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], BaseDialog.prototype, "close", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BaseDialog.prototype, "closeOnEscape", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BaseDialog.prototype, "closeOnOutsideClick", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], BaseDialog.prototype, "submit", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BaseDialog.prototype, "submitOnEnter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], BaseDialog.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseDialog.prototype, "minWidth", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BaseDialog.prototype, "minHeight", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BaseDialog.prototype, "resizing", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BaseDialog.prototype, "resizeEnd", void 0);
    __decorate([
        ViewChild('focusableElement'),
        __metadata("design:type", ElementRef)
    ], BaseDialog.prototype, "_focusableElement", void 0);
    BaseDialog = __decorate([
        Component({
            selector: 'base-dialog',
            template: "\n      <div class=\"modal-backdrop fade in\"></div>\n      <div style=\"display: block\" class=\"modal ui__modal\" tabindex=\"-1\" role=\"dialog\"\n      (click)=\"closeOnOutsideClick && close()\" (keydown.esc)=\"closeOnEscape && close()\" \n      [focus]=\"true\" #focusableElement>\n          <div [class]=\"'modal-dialog ' + cssClass\" (click)=\"preventClosing($event)\" >\n              <div class=\"modal-content base__height__full\" draggable [dragHandle]=\"dragHandle\" [ngStyle]=\"style\" mwlResizable [resizeCursorPrecision]=\"10\" [enableGhostResize]=\"false\"\n                  [resizeEdges]=\"{bottom: true, right: true, top: true, left: true}\"\n                  (resizing)=\"onResizing($event)\"\n                  (resizeEnd)=\"onResizeEnd($event)\">\n                  <div class=\"modal__header\" #dragHandle>\n                      <h3 class=\"modal-title\">\n                          <ng-content select='[title]'></ng-content>\n                      </h3>\n                      <i (click)=\"close()\" class=\"fa fa-close\"></i>\n                  </div>\n\n                  <div class=\"modal__body\" [class.modal__without__footer]=\"footerRef.children.length === 0\" (keydown.enter)=\"submitOnEnter && submit()\">\n                      <ng-content select='[body]'></ng-content>\n                  </div>\n\n                  <div class=\"modal__footer\" #footerRef [hidden]=\"footerRef.children.length === 0\">\n                      <ng-content select='[footer]'></ng-content>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        })
    ], BaseDialog);
    return BaseDialog;
}());
export { BaseDialog };
//# sourceMappingURL=base-dialog.component.js.map