var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ElementRef, EventEmitter, Input, Output, ViewChild } from '@angular/core';
import { Observable } from 'rxjs';
import { BaseComponent } from '../base-component/base.component';
import { ImageLazyLoadDirective, LazyLoadDirective } from '../../directives';
var CardView = /** @class */ (function (_super) {
    __extends(CardView, _super);
    function CardView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.multiSelect = true;
        _this.loadNextPage = function (event) { };
        _this.totalCount = 0;
        _this.itemsPerPage = 100;
        _this.itemIdKey = 'systemId';
        _this.dragEnabled = false;
        _this.rowReorderEnabled = false;
        _this.expandThumbnail = false;
        _this.itemHeight = 202;
        _this.itemWidth = 197;
        _this.onSortOrderChanged = new EventEmitter();
        _this.itemDoubleClick = new EventEmitter();
        _this.selectedChanged = new EventEmitter();
        _this.onDragStart = new EventEmitter();
        _this.onDragEnd = new EventEmitter();
        _this.selectedIds = [];
        return _this;
    }
    CardView.prototype.reset = function () {
        this.lazyLoadDirective && this.lazyLoadDirective.reset();
        this.deselect();
    };
    CardView.prototype.deselect = function () {
        this.selectedIds = [];
        this.lastIndex = 0;
        this.selectedChanged.emit(this.selectedIds);
    };
    CardView.prototype.fullHeight = function () {
        this.makeFullHeight(this.container);
    };
    Object.defineProperty(CardView.prototype, "startIndex", {
        get: function () {
            return this.lazyLoadDirective.startIndex;
        },
        set: function (index) {
            this.lazyLoadDirective.startIndex = index;
        },
        enumerable: true,
        configurable: true
    });
    CardView.prototype.select = function (id, ctrlKey, shiftKey, index) {
        if (!this.multiSelect) {
            this.selectedIds = [];
        }
        if (ctrlKey) {
            var index_1 = this.selectedIds.indexOf(id);
            this.lastIndex = index_1;
            if (index_1 !== -1) {
                this.selectedIds.splice(index_1, 1);
            }
            else {
                this.selectedIds.push(id);
            }
        }
        else if (shiftKey && this.multiSelect) {
            this._selectItemsBetween(index, this.lastIndex);
        }
        else {
            this.selectedIds = [id];
            this.lastIndex = index;
        }
        this.selectedChanged.emit(this.selectedIds);
    };
    CardView.prototype._selectItemsBetween = function (startIndex, endIndex) {
        var _this = this;
        var start = Math.min(startIndex, endIndex);
        var end = Math.max(startIndex, endIndex);
        this.selectedIds = this.items.slice(start, end + 1).map(function (f) { return f[_this.itemIdKey]; });
    };
    CardView.prototype.onDndOrderSuccess = function () {
        this.onSortOrderChanged.emit(this.items);
    };
    CardView.prototype.ensureImageLoad = function () {
        this.imageLazyLoadDirective.markForCheck();
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "multiSelect", void 0);
    __decorate([
        Input('loading'),
        __metadata("design:type", Observable)
    ], CardView.prototype, "loading", void 0);
    __decorate([
        Input('loadNextPage'),
        __metadata("design:type", Function)
    ], CardView.prototype, "loadNextPage", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "totalCount", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], CardView.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "itemsPerPage", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CardView.prototype, "imageProp", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CardView.prototype, "nameProp", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "itemIdKey", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CardView.prototype, "iconClassProp", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "dragEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "rowReorderEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "expandThumbnail", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "itemHeight", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CardView.prototype, "itemWidth", void 0);
    __decorate([
        Output('onSortOrderChanged'),
        __metadata("design:type", Object)
    ], CardView.prototype, "onSortOrderChanged", void 0);
    __decorate([
        Output('itemDoubleClick'),
        __metadata("design:type", Object)
    ], CardView.prototype, "itemDoubleClick", void 0);
    __decorate([
        Output('selectedChanged'),
        __metadata("design:type", Object)
    ], CardView.prototype, "selectedChanged", void 0);
    __decorate([
        Output('onDragStart'),
        __metadata("design:type", Object)
    ], CardView.prototype, "onDragStart", void 0);
    __decorate([
        Output('onDragEnd'),
        __metadata("design:type", Object)
    ], CardView.prototype, "onDragEnd", void 0);
    __decorate([
        ViewChild(LazyLoadDirective),
        __metadata("design:type", LazyLoadDirective)
    ], CardView.prototype, "lazyLoadDirective", void 0);
    __decorate([
        ViewChild(ImageLazyLoadDirective),
        __metadata("design:type", ImageLazyLoadDirective)
    ], CardView.prototype, "imageLazyLoadDirective", void 0);
    __decorate([
        ViewChild('container'),
        __metadata("design:type", ElementRef)
    ], CardView.prototype, "container", void 0);
    CardView = __decorate([
        Component({
            selector: 'card-view',
            template: "\n      <div #container class=\"ui__scrollable-zone\" [imageLazyLoad]=\"loading\">\n          <div *ngIf=\"rowReorderEnabled\" dnd-sortable-container [sortableData]=\"items\" class=\"ui__list-container\" lazyLoad \n              (lazyLoad-next)=\"loadNextPage($event)\"\n              [lazyLoad-loading]=\"loading\"\n              [lazyLoad-itemsPerPage]=\"itemsPerPage\"\n              [lazyLoad-total]=\"totalCount\" \n              [lazyLoad-itemHeight]=\"itemHeight\" \n              [lazyLoad-itemWidth]=\"itemWidth\">\n              <div *ngFor=\"let item of items; let i = index\" class=\"card-view__item-container\" \n                  (dblclick)=\"itemDoubleClick.emit(item.systemId)\"\n                  [ngClass]=\"{'fa fa-check-circle card-view__item': true, 'card-view__item--selected selected': selectedIds.indexOf(item.systemId) !== -1}\"\n                  (click)=\"select(item.systemId, $event.ctrlKey || $event.metaKey, $event.shiftKey, i)\" \n                  dnd-draggable\n                  dnd-sortable [sortableIndex]=\"i\"\n                  [dragEnabled]=\"rowReorderEnabled || dragEnabled\"\n                  [dragData]=\"item.systemId\"\n                  (onDropSuccess)=\"onDndOrderSuccess()\"\n                  (onDragEnd)=\"onDragEnd.emit($event)\"\n                  (onDragStart)=\"onDragStart.emit(selectedIds.indexOf(item.systemId) !== -1 ? selectedIds : [item.systemId])\">\n                  <div *ngIf=\"item[imageProp]\" [ngClass]=\"{'card-view__image-container': !expandThumbnail, 'card-view__image-container--expand': expandThumbnail}\">\n                      <img class=\"card-view__image\" [attr.image-source]=\"item[imageProp]\"/>\n                      <span class=\"card-view__image-align\"></span>\n                  </div>\n                  <div *ngIf=\"!item[imageProp]\" class=\"card-view__thumbnail-container\">\n                      <i [ngClass]=\"['fa', item[iconClassProp] || '']\" aria-hidden=\"true\"></i>\n                  </div>\n                  <label class=\"card-view__item-name\" [title]=\"item[nameProp]\">{{item[nameProp]}}</label>\n              </div>\n          </div>\n          <div *ngIf=\"!rowReorderEnabled\" class=\"ui__list-container\" lazyLoad \n              (lazyLoad-next)=\"loadNextPage($event)\"\n              [lazyLoad-loading]=\"loading\"\n              [lazyLoad-itemsPerPage]=\"itemsPerPage\"\n              [lazyLoad-total]=\"totalCount\" \n              [lazyLoad-itemHeight]=\"itemHeight\" \n              [lazyLoad-itemWidth]=\"itemWidth\">\n              <div *ngFor=\"let item of items; let i = index\" class=\"card-view__item-container\" \n                  (dblclick)=\"itemDoubleClick.emit(item.systemId)\"\n                  [ngClass]=\"{'fa fa-check-circle card-view__item': true, 'card-view__item--selected selected': selectedIds.indexOf(item.systemId) !== -1}\"\n                  (click)=\"select(item.systemId, $event.ctrlKey || $event.metaKey, $event.shiftKey, i)\" \n                  dnd-draggable\n                  [dragEnabled]=\"dragEnabled\"\n                  [dragData]=\"item.systemId\"\n                  (onDragEnd)=\"onDragEnd.emit($event)\"\n                  (onDragStart)=\"onDragStart.emit(selectedIds.indexOf(item.systemId) !== -1 ? selectedIds : [item.systemId])\">\n                  <div *ngIf=\"item[imageProp]\" [ngClass]=\"{'card-view__image-container': !expandThumbnail, 'card-view__image-container--expand': expandThumbnail}\">\n                      <img class=\"card-view__image\" [attr.image-source]=\"item[imageProp]\"/>\n                      <span class=\"card-view__image-align\"></span>\n                  </div>\n                  <div *ngIf=\"!item[imageProp]\" class=\"card-view__thumbnail-container\">\n                      <i [ngClass]=\"['fa', item[iconClassProp] || '']\" aria-hidden=\"true\"></i>\n                  </div>\n                  <label class=\"card-view__item-name\" [title]=\"item[nameProp]\">{{item[nameProp]}}</label>\n              </div>\n          </div>\n      </div>\n    ",
        })
    ], CardView);
    return CardView;
}(BaseComponent));
export { CardView };
//# sourceMappingURL=card-view.component.js.map