var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ElementRef, EventEmitter, Input, Output, ViewChild, Renderer2 } from '@angular/core';
import { BaseComponent } from '../base-component/base.component';
var Dropdown = /** @class */ (function (_super) {
    __extends(Dropdown, _super);
    function Dropdown(_renderer) {
        var _this = _super.call(this) || this;
        _this._renderer = _renderer;
        _this.borderless = false;
        _this.isExpand = false;
        _this.showTooltip = false;
        _this.tooltip = _this.label;
        _this.disabled = false;
        _this.onExpand = new EventEmitter();
        return _this;
    }
    Dropdown.prototype.onClick = function (target) {
        if (!this.isExpand) {
            return;
        }
        this.isExpand = this.container.nativeElement.contains(target);
    };
    Dropdown.prototype.toggleDropdown = function (event) {
        this.isExpand = !this.isExpand;
        if (!this.isExpand) {
            return;
        }
        // implementation can have its own template, in case it does not define the
        // dropdown element reference, we should not update the dropdown location.
        if (!this.dropdown) {
            this.onExpand.emit(event);
            return;
        }
        this._renderer.removeStyle(this.dropdown.nativeElement, 'top');
        // by default, it gets the list item rect from the dropdown element.
        // consumer can listen to onExpand to overwrite the value.
        event.listItemRect = this.dropdown.nativeElement.getBoundingClientRect();
        this.onExpand.emit(event);
        var listItemRect = event.listItemRect;
        if (!listItemRect) {
            return;
        }
        // calculate the available space to decide to show the dropdown content above or below
        var dropdownRect = this.dropdown.nativeElement.getBoundingClientRect();
        if (dropdownRect.bottom > window.innerHeight && dropdownRect.top - listItemRect.height > 0) {
            this._renderer.setStyle(this.dropdown.nativeElement, 'top', "-" + (listItemRect.height + 5) + "px");
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], Dropdown.prototype, "label", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "borderless", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "isExpand", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "showTooltip", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "tooltip", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "disabled", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], Dropdown.prototype, "onExpand", void 0);
    __decorate([
        ViewChild('dropdown'),
        __metadata("design:type", ElementRef)
    ], Dropdown.prototype, "dropdown", void 0);
    __decorate([
        ViewChild('container'),
        __metadata("design:type", ElementRef)
    ], Dropdown.prototype, "container", void 0);
    Dropdown = __decorate([
        Component({
            selector: 'dropdown',
            template: "\n      <div class=\"ui__dropdown\" #container [ngClass]=\"{'open': isExpand, 'disabled': disabled}\">\n          <ng-container *ngIf=\"borderless\">\n              <span *ngIf=\"!showTooltip\" data-toggle=\"dropdown\" (click)=\"toggleDropdown($event)\">\n                  {{ label }} <i class=\"fa fa-chevron-down\"></i>\n              </span>\n              <span *ngIf=\"showTooltip\" data-toggle=\"dropdown\" (click)=\"toggleDropdown($event)\" [title]=\"tooltip\">\n                      {{ label }} <i class=\"fa fa-chevron-down\"></i>\n                  </span>\n          </ng-container>\n          <ng-container *ngIf=\"!borderless\">\n              <div *ngIf=\"!showTooltip\" class=\"dropdown__button\" (click)=\"toggleDropdown($event)\">\n                  <span>{{ label }}</span><i class=\"icon fa fa-fw\" [ngClass]=\"{'fa-chevron-down': !isExpand, 'fa-chevron-up': isExpand}\"></i>\n              </div>\n              <div *ngIf=\"showTooltip\" class=\"dropdown__button\" (click)=\"toggleDropdown($event)\" [title]=\"tooltip\">\n                      <span>{{ label }}</span><i class=\"icon fa fa-fw\" [ngClass]=\"{'fa-chevron-down': !isExpand, 'fa-chevron-up': isExpand}\"></i>\n                  </div>\n          </ng-container>\n    \n          <div #dropdown class=\"dropdown__list dropdown__list__right dropdown__full__row\" [style.opacity]=\"isExpand ? 1 : 0\" [style.z-index]=\"isExpand ? 1000 : -1\">\n              <ng-content></ng-content>\n          </div>\n      </div>\n    ",
            host: {
                '(document:click)': 'onClick($event.target)',
            },
            changeDetection: ChangeDetectionStrategy.OnPush,
        }),
        __metadata("design:paramtypes", [Renderer2])
    ], Dropdown);
    return Dropdown;
}(BaseComponent));
export { Dropdown };
//# sourceMappingURL=dropdown.component.js.map