var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Component, EventEmitter, Input, Output, ViewContainerRef, ViewChild, ChangeDetectorRef } from '@angular/core';
import isEqual from 'lodash-es/isEqual';
import { ExtendedFormGroup } from '../../forms/extended-form-group';
import { ComponentCreatorService } from '../../services/component-creator.service';
var DynamicComponent = /** @class */ (function () {
    function DynamicComponent(_componentCreator, _cdr) {
        this._componentCreator = _componentCreator;
        this._cdr = _cdr;
        this.eventListeners = {};
        this.onFormsReady = new EventEmitter();
        this.onEvent = new EventEmitter();
        this._forms = [];
        this._subcribers = [];
    }
    DynamicComponent.prototype.ngOnChanges = function (changes) {
        if (!changes['schema']) {
            return;
        }
        // reload schema only if 'schema.children' or 'schema.component' attributes are different
        var _a = changes['schema'], previousValue = _a.previousValue, currentValue = _a.currentValue;
        if (!currentValue) {
            this.mainContainer.clear();
            return;
        }
        if (previousValue && previousValue.component === currentValue.component
            && isEqual(previousValue.children, currentValue.children)) {
            return;
        }
        this._reload();
    };
    DynamicComponent.prototype.ngOnDestroy = function () {
        this._removeAllSubscriptions();
    };
    DynamicComponent.prototype._removeAllSubscriptions = function () {
        this._subcribers.forEach(function (s) { return s.unsubscribe(); });
        this._subcribers = [];
    };
    DynamicComponent.prototype._reload = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, component;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this._removeAllSubscriptions();
                        this.mainContainer.clear();
                        _a = this;
                        return [4 /*yield*/, this._componentCreator.generate(this.schema, this.defaultFormValues, this.mainContainer, this.form)];
                    case 1:
                        _a._forms = _b.sent();
                        this.onFormsReady.emit(this._forms);
                        component = this.mainContainer['childComponent'];
                        if (component) {
                            component.onChange && this._subcribers.push(component.onChange.subscribe(function (event) {
                                _this.onEvent.emit(event);
                            }));
                            component.onAfterViewInit && this._subcribers.push(component.onAfterViewInit.subscribe(function (event) {
                                _this.onEvent.emit(event);
                            }));
                            component.onFormsReady && this._subcribers.push(component.onFormsReady.subscribe(function (event) {
                                _this.onFormsReady.emit(event);
                            }));
                            // bind custom event to the component
                            Object.keys(this.eventListeners).forEach(function (eventName) {
                                component[eventName] && _this._subcribers.push(component[eventName].subscribe(function (event) {
                                    _this.eventListeners[eventName](event);
                                }));
                            });
                        }
                        // Ask Angular to check changes. There could be some components in the schema that
                        // are configured with OnPush change detection. There is a chance that those components
                        // will not render properly until we click on the component, which trigger the detect
                        // change of Angular.
                        this._cdr.markForCheck();
                        return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        ViewChild('mainContainer', { read: ViewContainerRef }),
        __metadata("design:type", ViewContainerRef)
    ], DynamicComponent.prototype, "mainContainer", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "schema", void 0);
    __decorate([
        Input(),
        __metadata("design:type", ExtendedFormGroup)
    ], DynamicComponent.prototype, "form", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "defaultFormValues", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "eventListeners", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "onFormsReady", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "onEvent", void 0);
    DynamicComponent = __decorate([
        Component({
            selector: 'dynamic-component',
            template: "\n      <ng-container #mainContainer></ng-container>\n    ",
        }),
        __metadata("design:paramtypes", [ComponentCreatorService, ChangeDetectorRef])
    ], DynamicComponent);
    return DynamicComponent;
}());
export { DynamicComponent };
//# sourceMappingURL=dynamic.component.js.map