import { EventEmitter, OnChanges, OnInit, SimpleChanges, ChangeDetectorRef } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
import { IAppState } from '../../redux/stores';
import { FormFieldActions } from '../../redux/actions/forms/form-field.actions';
import { LanguageSelector } from '../index';
import { Field } from '../../interfaces';
import { BaseComponent } from '../base-component/base.component';
export declare class FieldEditor extends BaseComponent implements OnInit, OnChanges {
    private _ngRedux;
    private _formfieldActions;
    protected _changeDetection: ChangeDetectorRef;
    errors: string[];
    private _readonly;
    field: Field;
    narrow: boolean;
    onStartEditing: EventEmitter<{}>;
    editable: boolean;
    readonly readonly: boolean;
    editLanguageComponent: LanguageSelector;
    viewLanguageComponent: LanguageSelector;
    constructor(_ngRedux: NgRedux<IAppState>, _formfieldActions: FormFieldActions, _changeDetection: ChangeDetectorRef);
    ngOnInit(): void;
    editButtonClick(): void;
    undo(): void;
    ngOnChanges(changes: SimpleChanges): void;
    _onStartEditing(edit: boolean): void;
    private _getViewLanguage;
    editIconClassMap(): {
        'fa-minus': boolean;
        'fa-pencil': boolean;
    };
}
