var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, Input, Output, ViewChild, ChangeDetectorRef } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
import { first, skip } from 'rxjs/operators';
import { FormFieldActions } from '../../redux/actions/forms/form-field.actions';
import { LanguageSelector } from '../index';
import { BaseComponent } from '../base-component/base.component';
var FieldEditor = /** @class */ (function (_super) {
    __extends(FieldEditor, _super);
    function FieldEditor(_ngRedux, _formfieldActions, _changeDetection) {
        var _this = _super.call(this) || this;
        _this._ngRedux = _ngRedux;
        _this._formfieldActions = _formfieldActions;
        _this._changeDetection = _changeDetection;
        _this._readonly = true;
        _this.narrow = false;
        _this.onStartEditing = new EventEmitter();
        return _this;
    }
    Object.defineProperty(FieldEditor.prototype, "editable", {
        get: function () {
            return this.field.editable;
        },
        set: function (value) {
            this.field.editable = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldEditor.prototype, "readonly", {
        get: function () {
            return this._readonly || this.field.readonly;
        },
        enumerable: true,
        configurable: true
    });
    FieldEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.on(this._ngRedux.select(function (state) { return state.formField.isEditAllGroup; }), function (editAll) {
            _this.editable = editAll;
            _this._onStartEditing(_this.editable);
            _this._changeDetection && _this._changeDetection.markForCheck();
        });
        this.on(this._ngRedux.select(function (state) { return state.error.submitFormField.byId[_this.field.name]; }).pipe(skip(1)), function (errors) {
            _this.errors = errors;
            _this._changeDetection && _this._changeDetection.markForCheck();
        });
        this.on(this._ngRedux.select(function (state) { return state.locale.languages; }).pipe(first()), function (languages) {
            _this.field.viewLanguage = _this._getViewLanguage(languages, _this.field.editLanguage);
            _this._changeDetection && _this._changeDetection.markForCheck();
        });
        this.on(this._ngRedux.select(function (state) { return state.formField.disabled; }), function (disable) {
            setTimeout(function () {
                _this._readonly = disable;
                _this._changeDetection && _this._changeDetection.markForCheck();
            }, 0);
        });
    };
    FieldEditor.prototype.editButtonClick = function () {
        this.editable = !this.editable;
        this._onStartEditing(this.editable);
        this._changeDetection && this._changeDetection.markForCheck();
    };
    FieldEditor.prototype.undo = function () {
        this.field.undo();
        // reset error
        this._formfieldActions.resetErrorDispatch(this.field.name);
        this._changeDetection && this._changeDetection.markForCheck();
    };
    FieldEditor.prototype.ngOnChanges = function (changes) {
        if (changes['editable']) {
            this._onStartEditing(changes['editable'].currentValue);
        }
    };
    FieldEditor.prototype._onStartEditing = function (edit) {
        if (!edit) {
            return;
        }
        // set the edit language to be the preview language
        this.field.editLanguage = this._ngRedux.getState().formField.previewLanguage;
        this.field.viewLanguage = this._getViewLanguage(this._ngRedux.getState().locale.languages, this.field.editLanguage);
        if (this.editLanguageComponent) {
            this.editLanguageComponent.value = this.field.editLanguage;
        }
        if (this.viewLanguageComponent) {
            this.viewLanguageComponent.value = this.field.viewLanguage;
        }
        this.onStartEditing.emit();
    };
    FieldEditor.prototype._getViewLanguage = function (languages, editLanguage) {
        var languageObject = languages.find(function (l) { return l.id !== editLanguage; });
        // select the first language which differs the edit language
        return languageObject ? languageObject.id : editLanguage;
    };
    FieldEditor.prototype.editIconClassMap = function () {
        return {
            'fa-minus': this.editable,
            'fa-pencil': !this.editable
        };
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], FieldEditor.prototype, "field", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], FieldEditor.prototype, "narrow", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], FieldEditor.prototype, "onStartEditing", void 0);
    __decorate([
        ViewChild('editLanguageComponent'),
        __metadata("design:type", LanguageSelector)
    ], FieldEditor.prototype, "editLanguageComponent", void 0);
    __decorate([
        ViewChild('viewLanguageComponent'),
        __metadata("design:type", LanguageSelector)
    ], FieldEditor.prototype, "viewLanguageComponent", void 0);
    FieldEditor = __decorate([
        Component({
            selector: 'field-editor',
            template: "\n      <div class=\"form__group__item\" [ngClass]=\"{'narrow': narrow}\">\n          <label class=\"form__label\">{{field.label}} <tooltip *ngIf=\"field.tooltip\" [text]=\"field.tooltip\"></tooltip></label>\n          <div class=\"form__group__item__edit\">\n              <a class=\"base__fake__link link--undo\" *ngIf=\"field.dirty\"\n                  (click)=\"undo()\">{{ 'fieldEditor.undo' | translate }}</a>\n              <span *ngIf=\"!readonly\" class=\"form__group__item__icon link--toggle\">\n                  <i class=\"fa fa-pencil\" [ngClass]=\"editIconClassMap()\" (click)=\"editButtonClick()\"></i>\n              </span>\n          </div>\n          <div class=\"form__field__include\">\n              <div class=\"form__group__item__container\">\n                  <div [ngClass]=\"editable ? 'row' : ''\">\n                      <div *ngIf=\"editable\" [class]=\"field.isCultureSpecific ? (narrow ? 'row__col__xs__12' : 'row__col__xs__6') : ''\">\n                          <p *ngIf=\"field.isCultureSpecific\">\n                              <span class=\"form__group__multi-lang-label\">{{ 'fieldEditor.edit' | translate }}</span>\n                              <language-selector #editLanguageComponent (change)=\"field.editLanguage = $event.target.value\"\n                                                  [attr.name]=\"field.name + '_culture'\"\n                                                  [value]=\"field.editLanguage\">\n                              </language-selector>\n                          </p>\n                          <p [class.error__form__group__item__container]=\"errors\">\n                              <ng-content select='[edit]'></ng-content>\n                          </p>\n                      </div>\n                      <div *ngIf=\"field.isCultureSpecific || !editable\" [ngClass]=\"editable ? (narrow ? 'row__col__xs__12' : 'row__col__xs__6') : ''\">\n                          <p *ngIf=\"editable\">\n                              <span class=\"form__group__multi-lang-label\">{{ 'fieldEditor.view' | translate }}</span>\n                              <language-selector #viewLanguageComponent (change)=\"field.viewLanguage = $event.target.value\" \n                                                  [value]=\"field.viewLanguage\">\n                              </language-selector>\n                          </p>\n                          <p>\n                              <ng-content select='[preview]'></ng-content>\n                          </p>\n                      </div>\n                  </div>\n              </div>\n          </div>\n          <div class=\"form__group__item__errors\" *ngIf=\"errors\">\n              <div *ngFor=\"let error of errors\" class=\"ui__message__container\">\n                  <span class=\"ui__message ui__message--error\">{{ error }}</span>\n              </div>\n          </div>\n      </div>\n    ",
        })
        /**
         * Represent the field editor wrapper, which renders language selectors, edit buttons, etc...
         * Field editor implementation should use <field-editor> and implement three ng-content sections:
         * - preview: section to preview field's data for preview language.
         * - edit: section to display the actual field editor.
         * - languagePreview: section to preview field's data on view language (the language selector)
         * next to the editor.
         */
        ,
        __metadata("design:paramtypes", [NgRedux,
            FormFieldActions,
            ChangeDetectorRef])
    ], FieldEditor);
    return FieldEditor;
}(BaseComponent));
export { FieldEditor };
//# sourceMappingURL=field-editor.component.js.map