var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, EventEmitter, Output, Input } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
import { BaseComponent } from '../base-component/base.component';
import { FieldActions } from '../../redux/actions';
/**
 * Represents the field selector component.
 */
var FieldSelector = /** @class */ (function (_super) {
    __extends(FieldSelector, _super);
    function FieldSelector(_ngRedux, _fieldActions) {
        var _this = _super.call(this) || this;
        _this._ngRedux = _ngRedux;
        _this._fieldActions = _fieldActions;
        _this.visibleIds = null;
        _this.idSelector = function (field) { return _this._idSelector(field); };
        _this.textSelector = function (field) { return _this._textSelector(field); };
        _this.stateSelector = function (state) { return state.settings.field.entities; };
        _this.manualFetch = false;
        _this.onFieldSelect = new EventEmitter();
        _this.isChecked = function (field) { return _this.value && _this.value.findIndex(function (f) { return _this.idSelector(f) === _this.idSelector(field); }) !== -1; };
        _this._idSelector = function (field) { return field.id; };
        _this._textSelector = function (field) { return field.title; };
        return _this;
    }
    FieldSelector.prototype.ngOnInit = function () {
        var _this = this;
        this.on(this._ngRedux.select(function (state) { return _this.stateSelector(state); }), function (fields) { return _this._fields = fields; });
        !this.manualFetch && this._fieldActions.queryDispatch("/Litium/app/api/" + this.areaName + "/fields", 'fieldSelector', null, true);
    };
    Object.defineProperty(FieldSelector.prototype, "fields", {
        get: function () {
            var _this = this;
            if (!this.visibleIds) {
                return this._fields;
            }
            return this._fields.filter(function (field) { return _this.visibleIds.indexOf(_this.idSelector(field.id)) !== -1; });
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], FieldSelector.prototype, "visibleIds", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FieldSelector.prototype, "areaName", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], FieldSelector.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], FieldSelector.prototype, "idSelector", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], FieldSelector.prototype, "textSelector", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], FieldSelector.prototype, "stateSelector", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], FieldSelector.prototype, "manualFetch", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], FieldSelector.prototype, "onFieldSelect", void 0);
    FieldSelector = __decorate([
        Component({
            selector: 'field-selector',
            template: "\n      <multi-select \n          [label]=\"'setting.fieldSelector.addField' | translate\"\n          [options]=\"fields\"\n          [idSelector]=\"idSelector\"\n          [textSelector]=\"textSelector\"\n          [isChecked]=\"isChecked\"\n          (onOptionChange)=\"onFieldSelect.emit($event)\">\n      </multi-select>\n    ",
            changeDetection: ChangeDetectionStrategy.OnPush,
        }),
        __metadata("design:paramtypes", [NgRedux, FieldActions])
    ], FieldSelector);
    return FieldSelector;
}(BaseComponent));
export { FieldSelector };
//# sourceMappingURL=field-selector.component.js.map