import { ElementRef, EventEmitter, QueryList, TemplateRef } from '@angular/core';
import { CardView } from '../card-view/card-view.component';
import { ColumnResizerDirective } from '../../directives';
import { ExtendedFormGroup } from '../../forms/extended-form-group';
import { DynamicComponent } from '../dynamic-component/dynamic.component';
export declare class ListView extends CardView {
    columnOption: any;
    columnReorderEnabled: boolean;
    selectedStyle: boolean;
    itemHeight: number;
    showHeader: boolean;
    form: ExtendedFormGroup;
    sortChange: EventEmitter<{}>;
    columnWidthChange: EventEmitter<{}>;
    onColumnOrderChange: EventEmitter<{}>;
    onItemValueChange: EventEmitter<{}>;
    columnResizerDirectives: QueryList<ColumnResizerDirective>;
    dynamicComponents: QueryList<DynamicComponent>;
    itemListContainer: ElementRef;
    headerContainer: ElementRef;
    actionsTemplate: TemplateRef<any>;
    actionsWidth: number;
    getRowStyle: Function;
    fullHeight(): void;
    columnResizable: (index: number) => boolean;
    getHeaderClass(fieldId: string): "" | {
        'fa-chevron-up': boolean;
        'fa-chevron-down': boolean;
    };
    onSortChange(column: any): void;
    onColumnOrderChanged(): void;
    /**
     * Parse template string to schema object. For example: 'PermissionList#propagateSupport=true;category="Container"'.
     * This will build the schema object based on the component name PermissionList, as well as
     * build the defaultFormValues based on the key-value data propagateSupport=true;category="Container".
     * The template string can also contain the object accessor for example: name="{groupSystemId}Readable", where
     * {groupSystemId} will be evaluated against the current list item, to get the actual item.groupSystemId value.
     */
    toSchema(template: string, object: any, attributeName?: string): any;
    private _evaluatePropertyAccessor;
    private _getDynamicComponentName;
    onDoubleClick(event: any, itemId: any): void;
    onDynamicItemValueChange(value: any, item: any, attributeName: any): void;
}
