var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ElementRef, EventEmitter, Input, Output, QueryList, TemplateRef, ViewChild, ViewChildren } from '@angular/core';
import { FormControl } from '@angular/forms';
import { CardView } from '../card-view/card-view.component';
import { ColumnResizerDirective } from '../../directives';
import { ExtendedFormGroup } from '../../forms/extended-form-group';
import { DynamicComponent } from '../dynamic-component/dynamic.component';
var ListView = /** @class */ (function (_super) {
    __extends(ListView, _super);
    function ListView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.columnReorderEnabled = true;
        _this.selectedStyle = true;
        _this.itemHeight = 40;
        _this.showHeader = true;
        _this.sortChange = new EventEmitter();
        _this.columnWidthChange = new EventEmitter();
        _this.onColumnOrderChange = new EventEmitter();
        _this.onItemValueChange = new EventEmitter();
        _this.actionsWidth = 50;
        _this.getRowStyle = function () {
            return {
                'height': _this.itemHeight + "px",
            };
        };
        _this.columnResizable = function (index) {
            if (!_this.columnResizerDirectives || !_this.columnResizerDirectives.length) {
                return false;
            }
            var currentDirective = _this.columnResizerDirectives.find(function (item) { return item.index === index; });
            return currentDirective ? currentDirective.resizable : false;
        };
        return _this;
    }
    ListView.prototype.fullHeight = function () {
        var _this = this;
        this.makeFullHeight(this.container);
        setTimeout(function () { return _this.makeFullHeight(_this.itemListContainer); }, 0);
    };
    ListView.prototype.getHeaderClass = function (fieldId) {
        if (!this.columnOption.sort) {
            return '';
        }
        var sortValue = (this.columnOption.sort.find(function (c) { return c.field === fieldId; }) || {}).dir;
        return {
            'fa-chevron-up': sortValue === 'asc',
            'fa-chevron-down': sortValue === 'desc'
        };
    };
    ListView.prototype.onSortChange = function (column) {
        var sortColumn = (this.columnOption.sort || []).find(function (c) { return c.field === column.field; });
        var sortDirection = !sortColumn || sortColumn.dir === 'desc' ? 'asc' : 'desc';
        var sort = [{ field: column.field, dir: sortDirection }];
        this.sortChange.emit(sort);
    };
    ListView.prototype.onColumnOrderChanged = function () {
        this.onColumnOrderChange.emit(this.columnOption.columns);
    };
    /**
     * Parse template string to schema object. For example: 'PermissionList#propagateSupport=true;category="Container"'.
     * This will build the schema object based on the component name PermissionList, as well as
     * build the defaultFormValues based on the key-value data propagateSupport=true;category="Container".
     * The template string can also contain the object accessor for example: name="{groupSystemId}Readable", where
     * {groupSystemId} will be evaluated against the current list item, to get the actual item.groupSystemId value.
     */
    ListView.prototype.toSchema = function (template, object, attributeName) {
        var _this = this;
        if (attributeName === void 0) { attributeName = null; }
        if (!template) {
            return;
        }
        var arr = template.split(/[#;]/), component = arr[0], data = arr.slice(1);
        var attributes = {};
        if (data && data.length) {
            data.forEach(function (item) {
                var keyValue = item.split(/[=]/);
                attributes[keyValue[0]] = JSON.parse(_this._evaluatePropertyAccessor(object, keyValue[1]));
            });
        }
        if (this.form) {
            attributes['form'] = this.form;
        }
        if (attributeName) {
            var value = object[attributeName];
            if (typeof value !== 'undefined') {
                attributes['value'] = value;
            }
            attributes.name = this._getDynamicComponentName(object, attributeName);
            if (attributes.type === 'input' && this.form) {
                if (!this.form.controls[attributes.name]) {
                    this.form.addControl(attributes.name, new FormControl(value), true);
                }
            }
        }
        return {
            component: component,
            attributes: attributes
        };
    };
    ListView.prototype._evaluatePropertyAccessor = function (object, script) {
        var arr = script.split(/[{}]/);
        if (arr.length > 1) {
            return "" + arr[0] + object[arr[1]] + arr[2];
        }
        return script;
    };
    ListView.prototype._getDynamicComponentName = function (objectValue, attributeName) {
        return "" + objectValue[this.itemIdKey] + attributeName;
    };
    ListView.prototype.onDoubleClick = function (event, itemId) {
        this.itemDoubleClick.emit(itemId);
        event.stopPropagation();
    };
    ListView.prototype.onDynamicItemValueChange = function (value, item, attributeName) {
        var _this = this;
        var eventArg = { value: value, item: item, attributeName: attributeName };
        this.onItemValueChange.emit(eventArg);
        if (!this.form) {
            if (value && value.stopPropagation) {
                value.stopPropagation();
            }
            return;
        }
        var control = this.form.controls[this._getDynamicComponentName(item, attributeName)];
        if (eventArg.dirty) {
            control.markAsDirty();
        }
        else {
            control.markAsPristine();
        }
        if (eventArg.newValue) {
            control.setValue(eventArg.newValue);
        }
        // enable items
        if (eventArg.enableFields && eventArg.enableFields.length) {
            eventArg.enableFields.forEach(function (enableField) {
                if (!_this.dynamicComponents || !_this.dynamicComponents.length) {
                    return;
                }
                var controlName = _this._getDynamicComponentName(item, enableField);
                var foundComponent = _this.dynamicComponents.find(function (component) {
                    return component.mainContainer['childComponent'] && component.mainContainer['childComponent'].name === controlName;
                });
                if (foundComponent && foundComponent.mainContainer['childComponent']) {
                    foundComponent.mainContainer['childComponent']['readonly'] = false;
                }
            });
        }
        // disable items
        if (eventArg.disableFields && eventArg.disableFields.length) {
            eventArg.disableFields.forEach(function (disableField) {
                if (!_this.dynamicComponents || !_this.dynamicComponents.length) {
                    return;
                }
                var controlName = _this._getDynamicComponentName(item, disableField);
                var foundComponent = _this.dynamicComponents.find(function (component) {
                    return component.mainContainer['childComponent'] && component.mainContainer['childComponent'].name === controlName;
                });
                if (foundComponent && foundComponent.mainContainer['childComponent']) {
                    foundComponent.mainContainer['childComponent']['readonly'] = true;
                }
            });
        }
        if (value && value.stopPropagation) {
            value.stopPropagation();
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ListView.prototype, "columnOption", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ListView.prototype, "columnReorderEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ListView.prototype, "selectedStyle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ListView.prototype, "itemHeight", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ListView.prototype, "showHeader", void 0);
    __decorate([
        Input(),
        __metadata("design:type", ExtendedFormGroup)
    ], ListView.prototype, "form", void 0);
    __decorate([
        Output('sortChange'),
        __metadata("design:type", Object)
    ], ListView.prototype, "sortChange", void 0);
    __decorate([
        Output('onColumnWidthChange'),
        __metadata("design:type", Object)
    ], ListView.prototype, "columnWidthChange", void 0);
    __decorate([
        Output('onColumnOrderChange'),
        __metadata("design:type", Object)
    ], ListView.prototype, "onColumnOrderChange", void 0);
    __decorate([
        Output('onItemValueChange'),
        __metadata("design:type", Object)
    ], ListView.prototype, "onItemValueChange", void 0);
    __decorate([
        ViewChildren(ColumnResizerDirective),
        __metadata("design:type", QueryList)
    ], ListView.prototype, "columnResizerDirectives", void 0);
    __decorate([
        ViewChildren(DynamicComponent),
        __metadata("design:type", QueryList)
    ], ListView.prototype, "dynamicComponents", void 0);
    __decorate([
        ViewChild('itemListContainer'),
        __metadata("design:type", ElementRef)
    ], ListView.prototype, "itemListContainer", void 0);
    __decorate([
        ViewChild('headerContainer'),
        __metadata("design:type", ElementRef)
    ], ListView.prototype, "headerContainer", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], ListView.prototype, "actionsTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ListView.prototype, "actionsWidth", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], ListView.prototype, "getRowStyle", void 0);
    ListView = __decorate([
        Component({
            selector: 'list-view',
            template: "\n      <div #container class=\"list-view\">\n          <div *ngIf=\"showHeader\" class=\"list-view__header-wrapper\">\n              <div class=\"list-view__header\" #headerContainer>\n                  <table #tableHeader class=\"list-view__header-table\">\n                      <colgroup>\n                          <col [style.width]=\"column.width + 'px'\" *ngFor=\"let column of columnOption.columns\">\n                          <col *ngIf=\"actionsTemplate\" [style.width]=\"actionsWidth + 'px'\">\n                      </colgroup>\n                      <thead>\n                          <tr dnd-sortable-container [sortableData]=\"columnOption.columns\">\n                              <th *ngFor=\"let column of columnOption.columns; let i = index\" columnResizer \n                                  [columnResizer-header]=\"tableHeader\" \n                                  [columnResizer-content]=\"tableContent\"\n                                  (columnResizer-onChange)=\"columnWidthChange.emit($event)\"\n                                  dnd-sortable [sortableIndex]=\"i\" [dragEnabled]=\"columnReorderEnabled && !columnResizable(i)\"\n                                  (onDropSuccess)=\"onColumnOrderChanged()\">\n                                  <div class=\"ui__header ui__header__sortable\" [ngClass]=\"{'list-view__header-item': true, 'list-view__header-item--sortable': column.sortable}\" (click)=\"column.sortable && onSortChange(column)\">\n                                      {{column.title}}\n                                      <tooltip *ngIf=\"column.tooltip\" [text]=\"column.tooltip\"></tooltip>\n                                      <i *ngIf=\"column.sortable\" class=\"fa\" [ngClass]=\"getHeaderClass(column.field)\" aria-hidden=\"true\"></i>\n                                  </div>\n                              </th>\n                              <th *ngIf=\"actionsTemplate\"></th>\n                          </tr>\n                      </thead>\n                  </table>\n              </div>\n          </div>\n          <div #itemListContainer [imageLazyLoad]=\"loading\" [ngClass]=\"{'list-view__body': true, 'list-view__body--without-header': !showHeader}\" (scroll)=\"headerContainer && headerContainer.nativeElement.scrollLeft = $event.target.scrollLeft\">\n              <div lazyLoad \n                  (lazyLoad-next)=\"loadNextPage($event)\"\n                  [lazyLoad-loading]=\"loading\"\n                  [lazyLoad-itemsPerPage]=\"itemsPerPage\"\n                  [lazyLoad-total]=\"totalCount\" \n                  [lazyLoad-itemHeight]=\"itemHeight\" \n                  [lazyLoad-paddingBottom]=\"0\"\n                  [lazyLoad-paddingTop]=\"0\"\n                  [lazyLoad-itemWidth]=\"-1\">\n                  <table #tableContent class=\"list-view__body-table\">\n                      <colgroup>\n                          <col [style.width]=\"column.width + 'px'\" *ngFor=\"let column of columnOption.columns\">\n                          <col *ngIf=\"actionsTemplate\" [style.width]=\"actionsWidth + 'px'\">\n                      </colgroup>\n                      <tbody *ngIf=\"rowReorderEnabled\" dnd-sortable-container [sortableData]=\"items\">\n                          <tr *ngFor=\"let item of items; let i = index\" [class.selected]=\"selectedStyle && selectedIds.indexOf(item[itemIdKey]) !== -1\" \n                              dnd-sortable [sortableIndex]=\"i\" [dragEnabled]=\"rowReorderEnabled || dragEnabled\"\n                              dnd-draggable\n                              [dragData]=\"item.systemId\"\n                              (onDragStart)=\"onDragStart.emit(selectedIds.indexOf(item.systemId) !== -1 ? selectedIds : [item.systemId])\"\n                              (onDragEnd)=\"onDragEnd.emit($event)\"\n                              (onDropSuccess)=\"onDndOrderSuccess()\"\n                              (click)=\"select(item[itemIdKey], $event.ctrlKey || $event.metaKey, $event.shiftKey, i)\"\n                              (dblclick)=\"onDoubleClick($event,item[itemIdKey])\"\n                              [ngStyle]=\"getRowStyle()\">\n                              <td *ngFor=\"let column of columnOption.columns\" [class.single-line]=\"!column.multiLines\">\n                                  <div class=\"list-view__body-table-cell\" *ngIf=\"column.componentTemplate; else staticTemplate\">\n                                      <dynamic-component \n                                          [form]=\"form\"\n                                          [schema]=\"toSchema(column.componentTemplate, item, column.field)\"\n                                          (onEvent)=\"onDynamicItemValueChange($event, item, column.field)\" >\n                                      </dynamic-component>\n                                  </div>\n                                  <ng-template #staticTemplate>\n                                      <div *ngIf=\"column.template\" class=\"list-view__body-table-cell\" [innerHTML]=\"column.template | cellTemplate:item | sanitizeHtml\"></div>\n                                      <div *ngIf=\"!column.template\" class=\"list-view__body-table-cell\" [innerHTML]=\"item[column.field] | cellTransform:column.type:column.format | sanitizeHtml\"></div>\n                                  </ng-template>\n                              </td>\n                              <td *ngIf=\"actionsTemplate\">\n                                  <div class=\"list-view__body-table-cell ui__actions\">\n                                      <ng-template [ngTemplateOutlet]=\"actionsTemplate\" [ngTemplateOutletContext]=\"{ $implicit: item }\"></ng-template> \n                                  </div>\n                              </td>\n                          </tr>\n                      </tbody>\n                      <tbody *ngIf=\"!rowReorderEnabled\">\n                          <tr *ngFor=\"let item of items; let i = index\" [class.selected]=\"selectedStyle && selectedIds.indexOf(item[itemIdKey]) !== -1\" \n                              (click)=\"select(item[itemIdKey], $event.ctrlKey || $event.metaKey, $event.shiftKey, i)\"\n                              (dblclick)=\"onDoubleClick($event,item[itemIdKey])\"\n                              dnd-draggable\n                              [dragEnabled]=\"dragEnabled\"\n                              [dragData]=\"item.systemId\"\n                              (onDragEnd)=\"onDragEnd.emit($event)\"\n                              (onDragStart)=\"onDragStart.emit(selectedIds.indexOf(item.systemId) !== -1 ? selectedIds : [item.systemId])\"\n                              [ngStyle]=\"getRowStyle()\">\n                              <td *ngFor=\"let column of columnOption.columns\" [class.single-line]=\"!column.multiLines\">\n                                  <div class=\"list-view__body-table-cell\" *ngIf=\"column.componentTemplate; else staticTemplate\">\n                                      <dynamic-component \n                                          [form]=\"form\"\n                                          [schema]=\"toSchema(column.componentTemplate, item, column.field)\"\n                                          (onEvent)=\"onDynamicItemValueChange($event, item, column.field)\" >\n                                      </dynamic-component>\n                                  </div>\n                                  <ng-template #staticTemplate>\n                                      <div *ngIf=\"column.template\" class=\"list-view__body-table-cell\" [innerHTML]=\"column.template | cellTemplate:item | sanitizeHtml\"></div>\n                                      <div *ngIf=\"!column.template\" class=\"list-view__body-table-cell\" [innerHTML]=\"item[column.field] | cellTransform:column.type:column.format | sanitizeHtml\"></div>\n                                  </ng-template>\n                              </td>\n                              <td *ngIf=\"actionsTemplate\">\n                                  <div class=\"list-view__body-table-cell ui__actions\">\n                                      <ng-template [ngTemplateOutlet]=\"actionsTemplate\" [ngTemplateOutletContext]=\"{ $implicit: item }\"></ng-template> \n                                  </div>\n                              </td>\n                          </tr>\n                      </tbody>\n                  </table>\n              </div>\n          </div>\n      </div>\n    ",
            styles: ["\n      .list-view table tbody tr {\n          color: #000;\n      }\n      .list-view table tbody tr.selected {\n          color: #fff;\n          background-color: #1494F6;\n          border-color: #1494F6;\n      }\n\n      .list-view table tbody tr.selected .thumbnail-container .fa {\n          color: #fff;\n      }\n    "],
        })
    ], ListView);
    return ListView;
}(CardView));
export { ListView };
//# sourceMappingURL=list-view.component.js.map