var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ElementRef, EventEmitter, Input, Output, ViewChild } from '@angular/core';
var nextId = 0;
var SingleSelect = /** @class */ (function () {
    function SingleSelect() {
        this.idSelector = function (option) { return String; };
        this.textSelector = function (option) { return String; };
        this.options = [];
        this.borderless = false;
        this.filerable = true;
        this.acceptNoneValue = true;
        this.disabled = false;
        this.onOptionChange = new EventEmitter();
        this.isOpen = false;
        this.isMultiSelect = false;
        this.inputId = "single-select-" + nextId++ + "-";
    }
    SingleSelect.prototype.onExpand = function (event) {
        var _this = this;
        this.isOpen = true;
        setTimeout(function () { return _this.filerable && _this.filterInput.nativeElement.focus(); }, 0);
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SingleSelect.prototype, "label", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], SingleSelect.prototype, "idSelector", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], SingleSelect.prototype, "textSelector", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "options", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "borderless", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "filerable", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "acceptNoneValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "disabled", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SingleSelect.prototype, "onOptionChange", void 0);
    __decorate([
        ViewChild('filterInput'),
        __metadata("design:type", ElementRef)
    ], SingleSelect.prototype, "filterInput", void 0);
    SingleSelect = __decorate([
        Component({
            selector: 'single-select',
            template: "\n      <dropdown [label]=\"label\" [borderless]=\"borderless\" [isExpand]=\"isOpen\" (onExpand)=\"onExpand($event)\" [disabled]=\"disabled\">\n          <div class=\"base__height__full\">\n              <div *ngIf=\"filerable\" class=\"filter\">\n                  <input #filterInput [(ngModel)]=\"filterText\" placeholder=\"{{ 'general.action.search' | translate }}\" />\n                  <i class=\"fa fa-search\"></i>\n              </div>\n              <ul>\n                  <ng-content></ng-content>\n                  <li *ngFor=\"let option of options | filter:textSelector:filterText; let i = index\" class=\"dropdown__list__item\" [class.readonly]=\"option.isGroup\">\n                      <b *ngIf=\"option.isGroup\" class=\"group\">{{textSelector(option) | translate}}</b>\n                      <ng-container *ngIf=\"!option.isGroup\">\n                          <ng-container *ngIf=\"isMultiSelect\">\n                              <input type=\"checkbox\" class=\"form__checkbox\" [id]=\"inputId + idSelector(option)\" [checked]=\"isChecked(option)\" \n                                  (change)=\"onOptionChange.emit({ option: option, checked: $event.target.checked})\" [disabled]=\"acceptNoneValue ? false: isChecked(option) && getNumOfChecked() === 1\">\n                              <label [for]=\"inputId + idSelector(option)\" class=\"base__width__full\">{{textSelector(option)}}</label>\n                          </ng-container>\n                          <ng-container *ngIf=\"!isMultiSelect\">\n                              <label [for]=\"inputId + idSelector(option)\" class=\"base__width__full\" \n                                  (click)=\"onOptionChange.emit({ option: option});isOpen = false\">{{textSelector(option)}}</label>\n                          </ng-container>\n                      </ng-container>\n                  </li>\n              </ul>\n              <div class=\"dropdown__accept__button\" *ngIf=\"isMultiSelect\">\n                  <button (click)=\"isOpen = false\">{{ 'general.action.ok' | translate }}</button>\n              </div>\n          </div>\n      </dropdown>\n    ",
            changeDetection: ChangeDetectionStrategy.OnPush,
        })
    ], SingleSelect);
    return SingleSelect;
}());
export { SingleSelect };
//# sourceMappingURL=single-select.component.js.map