import { OnInit, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { NgRedux } from '@angular-redux/store';
import { BaseComponent } from '../base-component/base.component';
import { ListView } from '../list-view/list-view.component';
import { IAppState } from '../../redux/stores';
import { ListActions } from '../../redux/actions';
/**
 * Represents the basic list, which accepts a list of items, provides
 * the lazy load function, and sort feature.
 */
export declare class SortableList extends BaseComponent implements OnInit {
    private _ngRedux;
    private _listActions;
    stateKey: string;
    itemDisplayKey: string;
    itemIdKey: string;
    showHeader: boolean;
    headerTitle: string;
    verticalPadding: number;
    sortable: boolean;
    entities: any[];
    loading$: Observable<boolean>;
    totalCount: number;
    gridOption: any;
    listView: ListView;
    actionsTemplate: TemplateRef<any>;
    private _loadingSubject;
    constructor(_ngRedux: NgRedux<IAppState>, _listActions: ListActions);
    items: any[];
    queryEntities: (event: any) => void;
    onSortOrderChanged(updatedItems: any[]): void;
    resize(): void;
    ngOnInit(): void;
    reset(): void;
}
