var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ContentChild, Input, TemplateRef, ViewChild } from '@angular/core';
import { Subject } from 'rxjs';
import { NgRedux } from '@angular-redux/store';
import { BaseComponent } from '../base-component/base.component';
import { ListView } from '../list-view/list-view.component';
import { ListActions } from '../../redux/actions';
/**
 * Represents the basic list, which accepts a list of items, provides
 * the lazy load function, and sort feature.
 */
var SortableList = /** @class */ (function (_super) {
    __extends(SortableList, _super);
    function SortableList(_ngRedux, _listActions) {
        var _this = _super.call(this) || this;
        _this._ngRedux = _ngRedux;
        _this._listActions = _listActions;
        _this.stateKey = 'sortableList';
        _this.itemDisplayKey = 'title';
        _this.itemIdKey = 'systemId';
        _this.showHeader = false;
        _this.headerTitle = '';
        _this.verticalPadding = 0;
        _this.sortable = true;
        _this.entities = [];
        _this._loadingSubject = new Subject();
        _this.queryEntities = function (event) {
            _this._loadingSubject.next(true);
            setTimeout(function () {
                _this._listActions.queryDispatch(_this.stateKey, event.startIndex, event.itemsPerPage);
                _this._loadingSubject.next(false);
            }, 0);
        };
        return _this;
    }
    Object.defineProperty(SortableList.prototype, "items", {
        get: function () {
            var list = this._ngRedux.getState().list.byKey[this.stateKey];
            return list ? list.items : [];
        },
        set: function (value) {
            this._listActions.setDispatch(this.stateKey, value);
            this.reset();
        },
        enumerable: true,
        configurable: true
    });
    SortableList.prototype.onSortOrderChanged = function (updatedItems) {
        this._listActions.modifyDispatch(this.stateKey, updatedItems);
    };
    SortableList.prototype.resize = function () {
        var containerNode = this.listView.container.nativeElement;
        containerNode.style.height = "calc(100% - " + this.verticalPadding + "px)";
    };
    SortableList.prototype.ngOnInit = function () {
        var _this = this;
        this.on(this._ngRedux.select(function (state) { return state.list.byKey[_this.stateKey]; }), function (list) {
            if (!list) {
                return;
            }
            _this.totalCount = list.totalCount;
            _this.entities = list.items || [];
        });
        this.gridOption = {
            columns: [{
                    field: this.itemDisplayKey,
                    title: this.headerTitle,
                    sortable: false
                }]
        };
        this.loading$ = this._loadingSubject.asObservable();
        setTimeout(function () { return _this.resize(); }, 0);
    };
    SortableList.prototype.reset = function () {
        this.listView && this.listView.reset();
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "stateKey", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "itemDisplayKey", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "itemIdKey", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "showHeader", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "headerTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "verticalPadding", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SortableList.prototype, "sortable", void 0);
    __decorate([
        ViewChild('listView'),
        __metadata("design:type", ListView)
    ], SortableList.prototype, "listView", void 0);
    __decorate([
        ContentChild(TemplateRef),
        __metadata("design:type", TemplateRef)
    ], SortableList.prototype, "actionsTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], SortableList.prototype, "items", null);
    SortableList = __decorate([
        Component({
            selector: 'sortable-list',
            template: "\n      <list-view #listView\n          (onSortOrderChanged)=\"onSortOrderChanged($event)\"\n          [showHeader]=\"showHeader\"\n          [rowReorderEnabled]=\"sortable\"\n          [loadNextPage]=\"queryEntities\"\n          [loading]=\"loading$\"\n          [items]=\"entities\"\n          [itemIdKey]=\"itemIdKey\"\n          [totalCount]=\"totalCount\"\n          [columnOption]=\"gridOption\"\n          [actionsTemplate]=\"actionsTemplate\"\n      >\n      </list-view>\n    "
        }),
        __metadata("design:paramtypes", [NgRedux, ListActions])
    ], SortableList);
    return SortableList;
}(BaseComponent));
export { SortableList };
//# sourceMappingURL=sortable-list.component.js.map