var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, EventEmitter, Input, Output } from '@angular/core';
var ColumnResizerDirective = /** @class */ (function () {
    function ColumnResizerDirective(_column) {
        this._column = _column;
        this.onColumnWidthChange = new EventEmitter();
        this._pressed = false;
        this._resizable = false;
    }
    ColumnResizerDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        var resizer = document.createElement('span');
        resizer.className = "ui__column__resizer";
        resizer.addEventListener('mousedown', function (event) { return _this._onMouseDown(event); });
        resizer.addEventListener('mouseover', function (event) { return _this._onHover(event); });
        this._column.nativeElement.insertBefore(resizer, this._column.nativeElement.firstChild);
        this._index = Array.from(this._column.nativeElement.parentNode.children).indexOf(this._column.nativeElement);
    };
    ColumnResizerDirective.prototype._setColumnWidth = function (index, width) {
        this.header.querySelector(this._columnIndexSelector(index)).style.width = width + "px";
        this.content.querySelector(this._columnIndexSelector(index)).style.width = width + "px";
    };
    ColumnResizerDirective.prototype._getColumnsWidth = function () {
        var data = Array.from(this.header.querySelectorAll('thead th')).map(function (dom, index) {
            return { index: index, width: dom.offsetWidth };
        });
        return data;
    };
    Object.defineProperty(ColumnResizerDirective.prototype, "index", {
        get: function () {
            return this._index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnResizerDirective.prototype, "resizable", {
        get: function () {
            return this._resizable;
        },
        enumerable: true,
        configurable: true
    });
    ColumnResizerDirective.prototype.onMouseMove = function (event) {
        if (!this._pressed) {
            this._resizable = false;
            return;
        }
        this._currentWidth = Math.max(this._initWidth + (event.clientX - this._initX), 25);
        this._setColumnWidth(this._index, this._currentWidth);
        this._updateTableWidth();
    };
    ColumnResizerDirective.prototype.onMouseUp = function () {
        if (!this._pressed) {
            return;
        }
        this._pressed = false;
        this._resizable = false;
        this.onColumnWidthChange.emit(this._getColumnsWidth());
    };
    ColumnResizerDirective.prototype._columnIndexSelector = function (index) {
        return "colgroup col:nth-child(" + (index + 1) + ")";
    };
    ColumnResizerDirective.prototype._headerIndexSelector = function (index) {
        return "thead th:nth-child(" + (index + 1) + ")";
    };
    ColumnResizerDirective.prototype._onMouseDown = function (event) {
        var _this = this;
        this._pressed = true;
        this._resizable = true;
        this._initX = event.clientX;
        this._initWidth = this.header.querySelector(this._headerIndexSelector(this._index)).offsetWidth;
        this._getColumnsWidth().forEach(function (c) { return _this._setColumnWidth(c.index, c.width); });
    };
    ColumnResizerDirective.prototype._onHover = function (event) {
        this._resizable = true;
    };
    ColumnResizerDirective.prototype._updateTableWidth = function () {
        var tableW = 0;
        Array.from(this.header.querySelectorAll('colgroup col')).forEach(function (elem) {
            tableW += elem.getBoundingClientRect().width;
        });
        this.header.style.width = tableW + "px";
        this.content.style.width = tableW + "px";
    };
    __decorate([
        Input('columnResizer-header'),
        __metadata("design:type", Object)
    ], ColumnResizerDirective.prototype, "header", void 0);
    __decorate([
        Input('columnResizer-content'),
        __metadata("design:type", Object)
    ], ColumnResizerDirective.prototype, "content", void 0);
    __decorate([
        Output('columnResizer-onChange'),
        __metadata("design:type", Object)
    ], ColumnResizerDirective.prototype, "onColumnWidthChange", void 0);
    ColumnResizerDirective = __decorate([
        Directive({
            selector: '[columnResizer]',
            host: {
                '(body:mousemove)': 'onMouseMove($event)',
                '(body:mouseup)': 'onMouseUp($event)',
            }
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], ColumnResizerDirective);
    return ColumnResizerDirective;
}());
export { ColumnResizerDirective };
//# sourceMappingURL=column-resizer.directive.js.map