import { ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { QueueRunnerService } from '../../services/queue-runner.service';
import { Paging } from '../../interfaces';
export declare class LazyLoadDirective extends QueueRunnerService<Paging> implements OnInit, OnDestroy, OnChanges {
    private _element;
    next: EventEmitter<{}>;
    loading: Observable<boolean>;
    total: number;
    itemHeight: number;
    /**
     * -1 means 100% full width
     */
    itemWidth: number;
    itemsPerPage: number;
    paddingBottom: number;
    paddingTop: number;
    private _bufferRow;
    private _currentItemCount;
    private _startIndex;
    queue: Paging[];
    constructor(_element: ElementRef);
    startIndex: number;
    _scrollableElement(): any;
    _gridElement(): any;
    onScroll(): void;
    onResize(): void;
    reset(): void;
    private _observer;
    private _onScrollSubscription;
    private _onResizeSubscription;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _load;
    _visibleRows(): number;
    updateItemDimensions(): void;
    _gridTotalHeight(): number;
    _onScrollInternal(): Promise<void>;
    run(item: Paging): Promise<void>;
    _itemsPerRow(): number;
    _getGridRect(): any;
    _numVisibleRows(): number;
    _getWrapperRect(): any;
}
