var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Directive, ElementRef, EventEmitter, Input, Output } from '@angular/core';
import { Observable, fromEvent } from 'rxjs';
import { debounceTime, skipWhile, take } from 'rxjs/operators';
var elementResizeDetector = require('element-resize-detector');
import { QueueRunnerService } from '../../services/queue-runner.service';
var LazyLoadDirective = /** @class */ (function (_super) {
    __extends(LazyLoadDirective, _super);
    function LazyLoadDirective(_element) {
        var _this = _super.call(this) || this;
        _this._element = _element;
        _this.next = new EventEmitter();
        _this.itemsPerPage = 100;
        _this.paddingBottom = 15;
        _this.paddingTop = 15;
        _this._bufferRow = 1;
        _this._currentItemCount = 0;
        _this._startIndex = 0;
        _this.queue = [];
        return _this;
    }
    Object.defineProperty(LazyLoadDirective.prototype, "startIndex", {
        get: function () {
            return this._startIndex;
        },
        set: function (index) {
            if (index && index >= 0) {
                this._startIndex = index;
            }
        },
        enumerable: true,
        configurable: true
    });
    LazyLoadDirective.prototype._scrollableElement = function () {
        return this._element.nativeElement.parentElement;
    };
    LazyLoadDirective.prototype._gridElement = function () {
        return this._element.nativeElement;
    };
    LazyLoadDirective.prototype.onScroll = function () {
        this._onScrollInternal();
    };
    LazyLoadDirective.prototype.onResize = function () {
        this.updateItemDimensions();
        this._onScrollInternal();
    };
    LazyLoadDirective.prototype.reset = function () {
        this._scrollableElement().scrollTop = 0;
        this._startIndex = 0;
        this._currentItemCount = this.itemsPerPage;
        this._load(this._startIndex, this.itemsPerPage);
        this._startIndex += this.itemsPerPage;
    };
    LazyLoadDirective.prototype.ngOnInit = function () {
        var _this = this;
        this._onResizeSubscription = fromEvent(window, 'resize').pipe(debounceTime(50)).subscribe(function () { return _this.onResize(); });
        this._onScrollSubscription = fromEvent(this._scrollableElement(), 'scroll').pipe(debounceTime(100)).subscribe(function () { return _this.onScroll(); });
        // at first load, the grid does not have scrollbar. But then it appears later, which makes the calculation wrong
        // we need to listen to its dimension changed event to re-calculate.
        this._observer = new elementResizeDetector();
        this._observer.listenTo(this._gridElement(), function (el) { return _this.onResize(); });
        this.updateItemDimensions();
    };
    LazyLoadDirective.prototype.ngOnChanges = function (changes) {
        if (changes.total) {
            this.updateItemDimensions();
        }
    };
    LazyLoadDirective.prototype.ngOnDestroy = function () {
        this._onScrollSubscription.unsubscribe();
        this._onResizeSubscription.unsubscribe();
        this._observer.removeAllListeners(this._gridElement());
    };
    LazyLoadDirective.prototype._load = function (startIndex, itemsPerPage) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.next.emit({ startIndex: startIndex, itemsPerPage: itemsPerPage });
                        if (!this.loading) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.loading.pipe(skipWhile(function (l) { return l === true; }), take(1)).toPromise()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LazyLoadDirective.prototype._visibleRows = function () {
        var rect = this._getGridRect();
        var visibleRows = this._numVisibleRows();
        var topScrollOffset = this._gridElement().offsetTop + rect.height - rect.bottom;
        return visibleRows + Math.floor(topScrollOffset / this.itemHeight);
    };
    LazyLoadDirective.prototype.updateItemDimensions = function () {
        this._gridElement().style.minHeight = this._gridTotalHeight() + 'px';
    };
    LazyLoadDirective.prototype._gridTotalHeight = function () {
        return Math.ceil(this.total / this._itemsPerRow()) * this.itemHeight + this.paddingBottom + this.paddingTop;
    };
    LazyLoadDirective.prototype._onScrollInternal = function () {
        return __awaiter(this, void 0, void 0, function () {
            var itemsPerRow, visibleItems, expectedItemsToShow;
            return __generator(this, function (_a) {
                itemsPerRow = this._itemsPerRow();
                visibleItems = this._visibleRows() * itemsPerRow;
                expectedItemsToShow = visibleItems + (itemsPerRow * this._bufferRow);
                expectedItemsToShow = expectedItemsToShow > this.total ? this.total : expectedItemsToShow;
                if ((expectedItemsToShow > this._currentItemCount && this._currentItemCount < this.total) || this._currentItemCount === 0) {
                    this._currentItemCount += this.itemsPerPage;
                    this.queue.push({ startIndex: this._startIndex, itemsPerPage: this.itemsPerPage });
                    this._startIndex += this.itemsPerPage;
                    this.resume();
                    if (expectedItemsToShow > this._currentItemCount && this._currentItemCount < this.total) {
                        this._onScrollInternal();
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    LazyLoadDirective.prototype.run = function (item) {
        return __awaiter(this, void 0, void 0, function () {
            var page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        page = this.queue.shift();
                        return [4 /*yield*/, this._load(page.startIndex, page.itemsPerPage)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LazyLoadDirective.prototype._itemsPerRow = function () {
        return this.itemWidth === -1 ? 1 : Math.floor(this._getGridRect().width / this.itemWidth);
    };
    LazyLoadDirective.prototype._getGridRect = function () {
        return this._gridElement().getBoundingClientRect();
    };
    LazyLoadDirective.prototype._numVisibleRows = function () {
        return Math.ceil(this._getWrapperRect().height / this.itemHeight);
    };
    LazyLoadDirective.prototype._getWrapperRect = function () {
        return this._scrollableElement().getBoundingClientRect();
    };
    __decorate([
        Output('lazyLoad-next'),
        __metadata("design:type", Object)
    ], LazyLoadDirective.prototype, "next", void 0);
    __decorate([
        Input('lazyLoad-loading'),
        __metadata("design:type", Observable)
    ], LazyLoadDirective.prototype, "loading", void 0);
    __decorate([
        Input('lazyLoad-total'),
        __metadata("design:type", Number)
    ], LazyLoadDirective.prototype, "total", void 0);
    __decorate([
        Input('lazyLoad-itemHeight'),
        __metadata("design:type", Number)
    ], LazyLoadDirective.prototype, "itemHeight", void 0);
    __decorate([
        Input('lazyLoad-itemWidth'),
        __metadata("design:type", Number)
    ], LazyLoadDirective.prototype, "itemWidth", void 0);
    __decorate([
        Input('lazyLoad-itemsPerPage'),
        __metadata("design:type", Object)
    ], LazyLoadDirective.prototype, "itemsPerPage", void 0);
    __decorate([
        Input('lazyLoad-paddingBottom'),
        __metadata("design:type", Object)
    ], LazyLoadDirective.prototype, "paddingBottom", void 0);
    __decorate([
        Input('lazyLoad-paddingTop'),
        __metadata("design:type", Object)
    ], LazyLoadDirective.prototype, "paddingTop", void 0);
    LazyLoadDirective = __decorate([
        Directive({
            selector: '[lazyLoad]'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], LazyLoadDirective);
    return LazyLoadDirective;
}(QueueRunnerService));
export { LazyLoadDirective };
//# sourceMappingURL=lazy-load.directive.js.map