var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
/*
 * Transform template to html string
 * Usage:
 *   value | cellTemplate:cellObj
 * Example:
 *   {{ '<img src="#= (field_00000000000000000000000000000017 == null ? '' : field_00000000000000000000000000000017) #" />' | cellTemplate:{field_00000000000000000000000000000017: 'text'}:'field_00000000000000000000000000000017'  }}
 *   formats to: text
*/
var CellTemplatePipe = /** @class */ (function () {
    function CellTemplatePipe() {
    }
    CellTemplatePipe.prototype.transform = function (template, cellObj) {
        if (!cellObj) {
            return template;
        }
        var extractArr = template.split(/[##]/);
        var output = '';
        var counter = 1;
        if (extractArr.length < 2 || extractArr[1].length < 1) {
            return template;
        }
        output = extractArr[0];
        while (counter + 1 < extractArr.length) {
            if (extractArr[counter].length < 1) {
                return output;
            }
            var expressionOutput = this._evalWithContext(extractArr[counter].substring(1, extractArr[counter].length), cellObj);
            output += "" + expressionOutput + extractArr[counter + 1];
            counter += 2;
        }
        if (counter > extractArr.length - 1) {
            return output;
        }
        else {
            return output + extractArr[extractArr.length - 1];
        }
    };
    CellTemplatePipe.prototype._evalWithContext = function (expression, context) {
        Object.keys(context).forEach(function (k) {
            expression = expression.split(new RegExp("\\b" + k + "\\b", 'g')).join('context.' + k);
        });
        try {
            // tslint:disable-next-line:no-eval
            return eval(expression);
        }
        catch (e) {
            return '';
        }
    };
    CellTemplatePipe = __decorate([
        Pipe({ name: 'cellTemplate' })
    ], CellTemplatePipe);
    return CellTemplatePipe;
}());
export { CellTemplatePipe };
//# sourceMappingURL=cell-template.pipe.js.map