var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
import { DateTransformPipe } from '../date-transform/date-transform.pipe';
import { LongTransformPipe } from '../long-transform/long-transform.pipe';
import { LiteralTextTransformPipe } from '../literal-text-transform/literal-text-transform.pipe';
/*
 * Transform cell data without template
 * Usage:
 *   value | cellTransform:type:format
 * Example:
 *   {{ 1024 | cellTransform:'long':'fileSize' }}
 *   formats to: 1KB
 *   '2015-04-17T00:00:00+00:00' | cellTransform:'date':'{0:dd/MM/yyyy}' }
 *   formats to: 17/04/2015
*/
var CellTransformPipe = /** @class */ (function () {
    function CellTransformPipe() {
        this._dateTransformPipe = new DateTransformPipe();
        this._longTransformPipe = new LongTransformPipe();
        this._literalTextTransformPipe = new LiteralTextTransformPipe();
    }
    CellTransformPipe.prototype.transform = function (value, type, format) {
        // invalid parameters
        if (!type) {
            return value;
        }
        switch (type) {
            case 'date':
                return this.formatDate(value, format);
            case 'long':
                return this.formatLong(value, format);
            case 'string':
                return this.formatString(value);
            default:
                return value;
        }
    };
    CellTransformPipe.prototype.formatDate = function (value, format) {
        return this._dateTransformPipe.transform(value, format);
    };
    CellTransformPipe.prototype.formatLong = function (value, format) {
        return this._longTransformPipe.transform(value, format);
    };
    CellTransformPipe.prototype.formatString = function (value) {
        return this._literalTextTransformPipe.transform(value);
    };
    CellTransformPipe = __decorate([
        Pipe({ name: 'cellTransform' })
    ], CellTransformPipe);
    return CellTransformPipe;
}());
export { CellTransformPipe };
//# sourceMappingURL=cell-transform.pipe.js.map