var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
import { DatePipe } from '@angular/common';
/*
 * Transform date type to custom format
 * Usage:
 *   value | dateTransform:format
 * Example:
 *   {{ '2015-04-17T00:00:00+00:00' | dateTransform:'{0:dd/MM/yyyy}' }}
 *   formats to: 17/04/2015
*/
var DateTransformPipe = /** @class */ (function () {
    function DateTransformPipe() {
        this._defaultLocale = 'en-US';
        this._datePipe = new DatePipe(this._defaultLocale);
    }
    DateTransformPipe.prototype.transform = function (value, format) {
        // invalid parameters
        if (!format || !value) {
            return value;
        }
        var date = new Date(value);
        // not date string
        if (!date.getTime || isNaN(date.getTime())) {
            return value;
        }
        var extractArr = format.split(/[{}]/);
        // wrong format
        if (extractArr.length < 2 || extractArr[1].length < 2) {
            return value;
        }
        var dateFormat = extractArr[1].substring(2, extractArr[1].length);
        if (!dateFormat) {
            return value;
        }
        return this.format(date, dateFormat);
    };
    DateTransformPipe.prototype.format = function (date, dateFormat) {
        return this._datePipe.transform(date, dateFormat);
    };
    DateTransformPipe = __decorate([
        Pipe({ name: 'dateTransform' })
    ], DateTransformPipe);
    return DateTransformPipe;
}());
export { DateTransformPipe };
//# sourceMappingURL=date-transform.pipe.js.map