var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
import { SizeTransformPipe } from '../size-transform/size-transform.pipe';
/*
 * Transform long type to custom format
 * Usage:
 *   value | longTransform:format
 * Example:
 *   {{ 1024 | longTransform:'fileSize' }}
 *   formats to: 1KB
*/
var LongTransformPipe = /** @class */ (function () {
    function LongTransformPipe() {
        this._sizeTransformPipe = new SizeTransformPipe();
    }
    LongTransformPipe.prototype.transform = function (value, format) {
        // invalid parameters
        if (!format || value === null || isNaN(value)) {
            return value;
        }
        switch (format) {
            case 'fileSize':
                return this._sizeTransformPipe.transform(value);
            default:
                return value;
        }
    };
    LongTransformPipe = __decorate([
        Pipe({ name: 'longTransform' })
    ], LongTransformPipe);
    return LongTransformPipe;
}());
export { LongTransformPipe };
//# sourceMappingURL=long-transform.pipe.js.map