var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
/*
 * Transform size from bytes
 * Usage:
 *   value | fileSize
 * Example:
 *   {{ 1024 | fileSize}}
 *   formats to: 1KB
*/
var SizeTransformPipe = /** @class */ (function () {
    function SizeTransformPipe() {
    }
    SizeTransformPipe.prototype.transform = function (value) {
        if (value === void 0) { value = 0; }
        var STEP = 1024;
        var SIZE_POSTFIX = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
        if (value <= 0) {
            return '0 Byte';
        }
        var i = Math.floor(Math.log(value) / Math.log(STEP));
        var actualValue = this.round(value / Math.pow(STEP, i));
        if (actualValue < STEP / 2) {
            return actualValue + ' ' + SIZE_POSTFIX[i];
        }
        else {
            if (i >= SIZE_POSTFIX.length - 1) {
                return '> ' + (STEP / 2 - 1) + ' ' + SIZE_POSTFIX[SIZE_POSTFIX.length - 1];
            }
            return this.round(actualValue / STEP) + ' ' + SIZE_POSTFIX[i + 1];
        }
    };
    SizeTransformPipe.prototype.round = function (value) {
        if (value === void 0) { value = 0; }
        if (value) {
            return Math.round(value * 10) / 10; // round to 1 decimal
        }
        else {
            return value;
        }
    };
    SizeTransformPipe = __decorate([
        Pipe({ name: 'fileSize' })
    ], SizeTransformPipe);
    return SizeTransformPipe;
}());
export { SizeTransformPipe };
//# sourceMappingURL=size-transform.pipe.js.map