import { HttpClient } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { IAppState } from '../stores';
import { ErrorActions, LoadingActions } from '../actions';
export declare abstract class BaseEntityListActions {
    private _ngRedux;
    private _http;
    private _errorActions;
    private _loadingActions;
    static BASE_ENTITY_LIST_GET_SUCCESS: string;
    static BASE_ENTITY_LIST_DELETE_ENTITY: string;
    static BASE_ENTITY_LIST_CLEAR_ADD_ENTITY_ID: string;
    abstract readonly reducerName: string;
    constructor(_ngRedux: NgRedux<IAppState>, _http: HttpClient, _errorActions: ErrorActions, _loadingActions: LoadingActions);
    getSuccess(result: any, nameFilter: string): {
        type: string;
        reducerName: string;
        payload: {
            nameFilter: string;
            result: any;
        };
    };
    query(serviceUrl: string, pageName: string, nameFilter?: string, includeSystemFields?: boolean): any;
    queryDispatch(serviceUrl: string, pageName: string, nameFilter?: string, includeSystemFields?: boolean): void;
    deleteEntity(id: any): {
        type: string;
        reducerName: string;
        payload: {
            id: any;
        };
    };
    deleteEntityDispatch(id: any): void;
    clearAddedEntityId(): {
        type: string;
        reducerName: string;
    };
    clearAddedEntityIdDispatch(): void;
}
