var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { finalize } from 'rxjs/operators';
import { ErrorActions, LoadingActions } from '../actions';
var BaseEntityListActions = /** @class */ (function () {
    function BaseEntityListActions(_ngRedux, _http, _errorActions, _loadingActions) {
        this._ngRedux = _ngRedux;
        this._http = _http;
        this._errorActions = _errorActions;
        this._loadingActions = _loadingActions;
    }
    BaseEntityListActions_1 = BaseEntityListActions;
    BaseEntityListActions.prototype.getSuccess = function (result, nameFilter) {
        return {
            type: BaseEntityListActions_1.BASE_ENTITY_LIST_GET_SUCCESS,
            reducerName: this.reducerName,
            payload: {
                nameFilter: nameFilter,
                result: result
            }
        };
    };
    BaseEntityListActions.prototype.query = function (serviceUrl, pageName, nameFilter, includeSystemFields) {
        var _this = this;
        if (nameFilter === void 0) { nameFilter = ''; }
        if (includeSystemFields === void 0) { includeSystemFields = false; }
        return function (dispatch) {
            dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_FETCH_BASIC_LIST + "." + pageName, true));
            var params = new HttpParams();
            if (includeSystemFields) {
                params = params.set('includeSystemFields', 'true');
            }
            if (nameFilter) {
                params = params.set('nameFilter', nameFilter.trim());
            }
            return _this._http.get(serviceUrl, { params: params }).pipe(finalize(function () { return dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_FETCH_BASIC_LIST + "." + pageName, false)); })).subscribe(function (data) { return dispatch(_this.getSuccess(data, nameFilter)); }, function (error) { return dispatch(_this._errorActions.setError(LoadingActions.STATE_FETCH_BASIC_LIST + "." + pageName, error)); });
        };
    };
    BaseEntityListActions.prototype.queryDispatch = function (serviceUrl, pageName, nameFilter, includeSystemFields) {
        if (nameFilter === void 0) { nameFilter = ''; }
        if (includeSystemFields === void 0) { includeSystemFields = false; }
        this._ngRedux.dispatch(this.query(serviceUrl, pageName, nameFilter, includeSystemFields));
    };
    BaseEntityListActions.prototype.deleteEntity = function (id) {
        return {
            type: BaseEntityListActions_1.BASE_ENTITY_LIST_DELETE_ENTITY,
            reducerName: this.reducerName,
            payload: {
                id: id
            }
        };
    };
    BaseEntityListActions.prototype.deleteEntityDispatch = function (id) {
        this._ngRedux.dispatch(this.deleteEntity(id));
    };
    BaseEntityListActions.prototype.clearAddedEntityId = function () {
        return {
            type: BaseEntityListActions_1.BASE_ENTITY_LIST_CLEAR_ADD_ENTITY_ID,
            reducerName: this.reducerName,
        };
    };
    BaseEntityListActions.prototype.clearAddedEntityIdDispatch = function () {
        this._ngRedux.dispatch(this.clearAddedEntityId());
    };
    var BaseEntityListActions_1;
    BaseEntityListActions.BASE_ENTITY_LIST_GET_SUCCESS = 'BASE_ENTITY_LIST_GET_SUCCESS';
    BaseEntityListActions.BASE_ENTITY_LIST_DELETE_ENTITY = 'BASE_ENTITY_LIST_DELETE_ENTITY';
    BaseEntityListActions.BASE_ENTITY_LIST_CLEAR_ADD_ENTITY_ID = 'BASE_ENTITY_LIST_CLEAR_ADD_ENTITY_ID';
    BaseEntityListActions = BaseEntityListActions_1 = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NgRedux,
            HttpClient,
            ErrorActions,
            LoadingActions])
    ], BaseEntityListActions);
    return BaseEntityListActions;
}());
export { BaseEntityListActions };
//# sourceMappingURL=base-entity-list.actions.js.map