var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpErrorResponse } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
var ErrorActions = /** @class */ (function () {
    function ErrorActions(_ngRedux) {
        this._ngRedux = _ngRedux;
    }
    ErrorActions_1 = ErrorActions;
    ErrorActions.prototype.setErrorDispatch = function (stateKey, errorObject) {
        this._ngRedux.dispatch(this.setError(stateKey, errorObject));
    };
    ErrorActions.prototype.setError = function (stateKey, errorObject) {
        return {
            type: ErrorActions_1.SET_ERROR,
            payload: {
                stateKey: stateKey,
                errorObject: this.extractError(errorObject)
            }
        };
    };
    ErrorActions.prototype.extractError = function (error) {
        if (typeof error === 'string') {
            try {
                error = JSON.parse(error);
            }
            catch (_a) { }
        }
        if (error instanceof HttpErrorResponse) {
            var obj_1 = error.error ? (typeof error.error === 'string' ? JSON.parse(error.error) : error.error) : {};
            if (obj_1.modelState) {
                var errorAsArray_1 = [];
                obj_1.byId = {}; // byId helps us to retreive error messages for a field easier
                Object.keys(obj_1.modelState).forEach(function (k) {
                    if (k !== '$type') {
                        obj_1.modelState[k].$values.forEach(function (v) { return errorAsArray_1.push({ key: k, value: v }); });
                        obj_1.byId[k] = obj_1.modelState[k].$values.slice();
                    }
                });
                obj_1.modelState = errorAsArray_1;
            }
            if (error.headers) {
                obj_1.message = error.headers.get('x-notification-error') || obj_1.message;
            }
            if (!obj_1.message) {
                obj_1.message = error.message || obj_1.message;
            }
            return obj_1;
        }
        else {
            return {
                message: error.message || error.toString(),
                modelState: error.modelState || [],
                byId: error.byId || {}
            };
        }
    };
    var ErrorActions_1;
    ErrorActions.SET_ERROR = 'SET_ERROR';
    ErrorActions = ErrorActions_1 = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NgRedux])
    ], ErrorActions);
    return ErrorActions;
}());
export { ErrorActions };
//# sourceMappingURL=error.actions.js.map