import { HttpClient } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { IAppState } from '../../stores';
import { LoadingActions } from '../loading.actions';
import { ErrorActions } from '../error.actions';
export declare class FormFieldActions {
    private _ngRedux;
    private _http;
    private _loadingActions;
    private _errorActions;
    static FORM_FIELD_CHANGE_PREVIEW_LANGUAGE: string;
    static FORM_FIELD_EDIT_ALL_GROUP: string;
    static FORM_FIELD_EXPAND_ALL_GROUP: string;
    static FORM_FIELD_SUBMIT_REQUEST: string;
    static FORM_FIELD_SUBMIT_SUCCESS: string;
    static FORM_FIELD_LOAD_REQUEST: string;
    static FORM_FIELD_LOAD_SUCCESS: string;
    static FORM_FIELD_RESET_ALL_ERROR: string;
    static FORM_FIELD_RESET_ERROR: string;
    static FORM_FIELD_MARK_AS_DIRTY: string;
    static FORM_FIELD_MARK_AS_DISABLED: string;
    static FORM_FIELD_SHOW_PENDING_CHANGES_CONFIRM_DIALOG: string;
    static FORM_FIELD_HIDE_PENDING_CHANGES_CONFIRM_DIALOG: string;
    static FORM_FIELD_CONFIRM_LOSE_PENDING_CHANGES: string;
    static FORM_FIELD_UPDATE_SCHEMA: string;
    static FORM_FIELD_RELOAD_FORM: string;
    static FORM_FIELD_FORCE_SUBMIT: string;
    constructor(_ngRedux: NgRedux<IAppState>, _http: HttpClient, _loadingActions: LoadingActions, _errorActions: ErrorActions);
    loadValueRequest(id: string, modelKey: string, tag: string): {
        type: string;
        payload: {
            id: string;
            modelKey: string;
            tag: string;
        };
    };
    loadValueSuccess(value: any): {
        type: string;
        payload: {
            value: any;
        };
    };
    loadValueDispatch(id: string, modelKey: string, tag?: string, serviceUrl?: string): void;
    loadValue(id: string, modelKey: string, tag?: string, serviceUrl?: string): any;
    submitFormDispatch(formData: any, reloadSchema: boolean, ownerId: string, modelKey: string, tag?: string, onSubmitSuccessful?: any, onSubmitError?: any, serviceUrl?: string): void;
    submitForm(formData: any, reloadSchema: boolean, ownerId: string, modelKey: string, tag?: string, onSubmitSuccessful?: any, onSubmitError?: any, serviceUrl?: string): any;
    reloadForm(modelKey: string): {
        type: string;
        payload: {
            modelKey: string;
        };
    };
    submitFormRequest(form: any): {
        type: string;
        payload: {
            form: any;
        };
    };
    submitFormSuccess(result: any): {
        type: string;
        payload: {
            result: any;
        };
    };
    setPreviewLanguageDispatch(previewLanguage: string): void;
    setPreviewLanguage(previewLanguage: string): {
        type: string;
        payload: {
            previewLanguage: string;
        };
    };
    editAllDispatch(editAll: boolean): void;
    editAll(editAll: boolean): {
        type: string;
        payload: {
            editAll: boolean;
        };
    };
    expandAllDispatch(expandAll: boolean): void;
    expandAll(expandAll: boolean): {
        type: string;
        payload: {
            expandAll: boolean;
        };
    };
    resetAllErrorsDispatch(): void;
    resetAllErrors(): {
        type: string;
    };
    resetErrorDispatch(fieldName: string): void;
    resetError(fieldName: string): {
        type: string;
        fieldName: string;
    };
    markAsDirty(dirty: boolean): {
        type: string;
        payload: {
            dirty: boolean;
        };
    };
    markAsDirtyDispatch(dirty: boolean): void;
    markAsDisabled(disabled: boolean): {
        type: string;
        payload: {
            disabled: boolean;
        };
    };
    markAsDisabledDispatch(disabled: boolean): void;
    showPendingChangesConfirm(show: boolean): {
        type: string;
    };
    showPendingChangesConfirmDispatch(show: boolean): void;
    confirmLosePendingChanges(confirm: boolean): {
        type: string;
        payload: {
            losePendingChangeConfirm: boolean;
        };
    };
    confirmLosePendingChangesDispatch(confirm: boolean): void;
    dismissPendingChangesConfirmDispatch(): void;
    acceptPendingChangesConfirmDispatch(): void;
    updateSchema(name: string, schema: any): {
        type: string;
        payload: {
            name: string;
            schema: any;
        };
    };
    updateSchemaDispatch(name: string, schema: any): void;
    forceSubmitForm(): {
        type: string;
    };
    forceSubmitFormDispatch(): void;
}
