var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { finalize } from 'rxjs/operators';
import { LoadingActions } from '../loading.actions';
import { ErrorActions } from '../error.actions';
var FormFieldActions = /** @class */ (function () {
    function FormFieldActions(_ngRedux, _http, _loadingActions, _errorActions) {
        this._ngRedux = _ngRedux;
        this._http = _http;
        this._loadingActions = _loadingActions;
        this._errorActions = _errorActions;
    }
    FormFieldActions_1 = FormFieldActions;
    FormFieldActions.prototype.loadValueRequest = function (id, modelKey, tag) {
        return {
            type: FormFieldActions_1.FORM_FIELD_LOAD_REQUEST,
            payload: {
                id: id,
                modelKey: modelKey,
                tag: tag
            }
        };
    };
    FormFieldActions.prototype.loadValueSuccess = function (value) {
        return {
            type: FormFieldActions_1.FORM_FIELD_LOAD_SUCCESS,
            payload: {
                value: value
            }
        };
    };
    FormFieldActions.prototype.loadValueDispatch = function (id, modelKey, tag, serviceUrl) {
        this._ngRedux.dispatch(this.loadValue(id, modelKey, tag, serviceUrl));
    };
    FormFieldActions.prototype.loadValue = function (id, modelKey, tag, serviceUrl) {
        var _this = this;
        if (tag === void 0) { tag = ''; }
        if (serviceUrl === void 0) { serviceUrl = "/Litium/app/api/common/ObjectSchema/getpropertyvalue"; }
        return function (dispatch) {
            dispatch(_this.loadValueRequest(id, modelKey, tag));
            dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_LOADING_FIELD_FORM_VALUE, true));
            return _this._http.post(serviceUrl, { key: modelKey + "-" + tag, objectId: id }).pipe(finalize(function () { return dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_LOADING_FIELD_FORM_VALUE, false)); })).subscribe(function (data) { return dispatch(_this.loadValueSuccess(data)); }, function (error) { return dispatch(_this._errorActions.setError(LoadingActions.STATE_LOADING_FIELD_FORM_VALUE, error)); });
        };
    };
    FormFieldActions.prototype.submitFormDispatch = function (formData, reloadSchema, ownerId, modelKey, tag, onSubmitSuccessful, onSubmitError, serviceUrl) {
        if (onSubmitSuccessful === void 0) { onSubmitSuccessful = null; }
        if (onSubmitError === void 0) { onSubmitError = null; }
        this._ngRedux.dispatch(this.submitForm(formData, reloadSchema, ownerId, modelKey, tag, onSubmitSuccessful, onSubmitError, serviceUrl));
    };
    FormFieldActions.prototype.submitForm = function (formData, reloadSchema, ownerId, modelKey, tag, onSubmitSuccessful, onSubmitError, serviceUrl) {
        var _this = this;
        if (tag === void 0) { tag = ''; }
        if (onSubmitSuccessful === void 0) { onSubmitSuccessful = null; }
        if (onSubmitError === void 0) { onSubmitError = null; }
        if (serviceUrl === void 0) { serviceUrl = "/Litium/app/api/common/ObjectSchema/save"; }
        return function (dispatch) {
            dispatch(_this.submitFormRequest(formData));
            dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_SUBMIT_FORM_FIELD, true));
            return _this._http.post(serviceUrl, { key: modelKey + "-" + tag, formData: formData }).pipe(finalize(function () { return dispatch(_this._loadingActions.setIsLoading(LoadingActions.STATE_SUBMIT_FORM_FIELD, false)); })).subscribe(function (data) {
                onSubmitSuccessful && onSubmitSuccessful(data);
                dispatch(_this.submitFormSuccess(data));
                if (reloadSchema) {
                    dispatch(_this.reloadForm(modelKey));
                }
                else {
                    // reload form value after submission successful
                    dispatch(_this.loadValue(ownerId, modelKey, tag));
                }
            }, function (error) {
                onSubmitError && onSubmitError(error);
                dispatch(_this._errorActions.setError(LoadingActions.STATE_SUBMIT_FORM_FIELD, error));
            });
        };
    };
    FormFieldActions.prototype.reloadForm = function (modelKey) {
        return {
            type: FormFieldActions_1.FORM_FIELD_RELOAD_FORM,
            payload: {
                modelKey: modelKey
            }
        };
    };
    FormFieldActions.prototype.submitFormRequest = function (form) {
        return {
            type: FormFieldActions_1.FORM_FIELD_SUBMIT_REQUEST,
            payload: {
                form: form
            }
        };
    };
    FormFieldActions.prototype.submitFormSuccess = function (result) {
        return {
            type: FormFieldActions_1.FORM_FIELD_SUBMIT_SUCCESS,
            payload: {
                result: result
            }
        };
    };
    FormFieldActions.prototype.setPreviewLanguageDispatch = function (previewLanguage) {
        this._ngRedux.dispatch(this.setPreviewLanguage(previewLanguage));
    };
    FormFieldActions.prototype.setPreviewLanguage = function (previewLanguage) {
        return {
            type: FormFieldActions_1.FORM_FIELD_CHANGE_PREVIEW_LANGUAGE,
            payload: {
                previewLanguage: previewLanguage
            }
        };
    };
    FormFieldActions.prototype.editAllDispatch = function (editAll) {
        this._ngRedux.dispatch(this.editAll(editAll));
    };
    FormFieldActions.prototype.editAll = function (editAll) {
        return {
            type: FormFieldActions_1.FORM_FIELD_EDIT_ALL_GROUP,
            payload: {
                editAll: editAll,
            }
        };
    };
    FormFieldActions.prototype.expandAllDispatch = function (expandAll) {
        this._ngRedux.dispatch(this.expandAll(expandAll));
    };
    FormFieldActions.prototype.expandAll = function (expandAll) {
        return {
            type: FormFieldActions_1.FORM_FIELD_EXPAND_ALL_GROUP,
            payload: {
                expandAll: expandAll,
            }
        };
    };
    FormFieldActions.prototype.resetAllErrorsDispatch = function () {
        this._ngRedux.dispatch(this.resetAllErrors());
    };
    FormFieldActions.prototype.resetAllErrors = function () {
        return {
            type: FormFieldActions_1.FORM_FIELD_RESET_ALL_ERROR,
        };
    };
    FormFieldActions.prototype.resetErrorDispatch = function (fieldName) {
        this._ngRedux.dispatch(this.resetError(fieldName));
    };
    FormFieldActions.prototype.resetError = function (fieldName) {
        return {
            type: FormFieldActions_1.FORM_FIELD_RESET_ERROR,
            fieldName: fieldName,
        };
    };
    FormFieldActions.prototype.markAsDirty = function (dirty) {
        return {
            type: FormFieldActions_1.FORM_FIELD_MARK_AS_DIRTY,
            payload: {
                dirty: dirty
            }
        };
    };
    FormFieldActions.prototype.markAsDirtyDispatch = function (dirty) {
        this._ngRedux.dispatch(this.markAsDirty(dirty));
    };
    FormFieldActions.prototype.markAsDisabled = function (disabled) {
        return {
            type: FormFieldActions_1.FORM_FIELD_MARK_AS_DISABLED,
            payload: {
                disabled: disabled
            }
        };
    };
    FormFieldActions.prototype.markAsDisabledDispatch = function (disabled) {
        this._ngRedux.dispatch(this.markAsDisabled(disabled));
    };
    FormFieldActions.prototype.showPendingChangesConfirm = function (show) {
        return {
            type: show ? FormFieldActions_1.FORM_FIELD_SHOW_PENDING_CHANGES_CONFIRM_DIALOG : FormFieldActions_1.FORM_FIELD_HIDE_PENDING_CHANGES_CONFIRM_DIALOG,
        };
    };
    FormFieldActions.prototype.showPendingChangesConfirmDispatch = function (show) {
        this._ngRedux.dispatch(this.showPendingChangesConfirm(show));
    };
    FormFieldActions.prototype.confirmLosePendingChanges = function (confirm) {
        return {
            type: FormFieldActions_1.FORM_FIELD_CONFIRM_LOSE_PENDING_CHANGES,
            payload: {
                losePendingChangeConfirm: confirm
            }
        };
    };
    FormFieldActions.prototype.confirmLosePendingChangesDispatch = function (confirm) {
        this._ngRedux.dispatch(this.confirmLosePendingChanges(confirm));
    };
    FormFieldActions.prototype.dismissPendingChangesConfirmDispatch = function () {
        this.showPendingChangesConfirmDispatch(false);
        this.confirmLosePendingChangesDispatch(false);
    };
    FormFieldActions.prototype.acceptPendingChangesConfirmDispatch = function () {
        this.showPendingChangesConfirmDispatch(false);
        this.markAsDirtyDispatch(false);
        this.resetAllErrorsDispatch();
        this.confirmLosePendingChangesDispatch(true);
    };
    FormFieldActions.prototype.updateSchema = function (name, schema) {
        return {
            type: FormFieldActions_1.FORM_FIELD_UPDATE_SCHEMA,
            payload: {
                name: name,
                schema: schema,
            }
        };
    };
    FormFieldActions.prototype.updateSchemaDispatch = function (name, schema) {
        this._ngRedux.dispatch(this.updateSchema(name, schema));
    };
    FormFieldActions.prototype.forceSubmitForm = function () {
        return {
            type: FormFieldActions_1.FORM_FIELD_FORCE_SUBMIT,
        };
    };
    FormFieldActions.prototype.forceSubmitFormDispatch = function () {
        this._ngRedux.dispatch(this.forceSubmitForm());
    };
    var FormFieldActions_1;
    FormFieldActions.FORM_FIELD_CHANGE_PREVIEW_LANGUAGE = 'FORM_FIELD_CHANGE_PREVIEW_LANGUAGE';
    FormFieldActions.FORM_FIELD_EDIT_ALL_GROUP = 'FORM_FIELD_EDIT_ALL_GROUP';
    FormFieldActions.FORM_FIELD_EXPAND_ALL_GROUP = 'FORM_FIELD_EXPAND_ALL_GROUP';
    FormFieldActions.FORM_FIELD_SUBMIT_REQUEST = 'FORM_FIELD_SUBMIT_REQUEST';
    FormFieldActions.FORM_FIELD_SUBMIT_SUCCESS = 'FORM_FIELD_SUBMIT_SUCCESS';
    FormFieldActions.FORM_FIELD_LOAD_REQUEST = 'FORM_FIELD_LOAD_REQUEST';
    FormFieldActions.FORM_FIELD_LOAD_SUCCESS = 'FORM_FIELD_LOAD_SUCCESS';
    FormFieldActions.FORM_FIELD_RESET_ALL_ERROR = 'FORM_FIELD_RESET_ALL_ERROR';
    FormFieldActions.FORM_FIELD_RESET_ERROR = 'FORM_FIELD_RESET_ERROR';
    FormFieldActions.FORM_FIELD_MARK_AS_DIRTY = 'FORM_FIELD_MARK_AS_DIRTY';
    FormFieldActions.FORM_FIELD_MARK_AS_DISABLED = 'FORM_FIELD_MARK_AS_DISABLED';
    FormFieldActions.FORM_FIELD_SHOW_PENDING_CHANGES_CONFIRM_DIALOG = 'FORM_FIELD_SHOW_PENDING_CHANGES_CONFIRM_DIALOG';
    FormFieldActions.FORM_FIELD_HIDE_PENDING_CHANGES_CONFIRM_DIALOG = 'FORM_FIELD_HIDE_PENDING_CHANGES_CONFIRM_DIALOG';
    FormFieldActions.FORM_FIELD_CONFIRM_LOSE_PENDING_CHANGES = 'FORM_FIELD_CONFIRM_LOSE_PENDING_CHANGES';
    FormFieldActions.FORM_FIELD_UPDATE_SCHEMA = 'FORM_FIELD_UPDATE_SCHEMA';
    FormFieldActions.FORM_FIELD_RELOAD_FORM = 'FORM_FIELD_RELOAD_FORM';
    FormFieldActions.FORM_FIELD_FORCE_SUBMIT = 'FORM_FIELD_FORCE_SUBMIT';
    FormFieldActions = FormFieldActions_1 = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NgRedux,
            HttpClient,
            LoadingActions,
            ErrorActions])
    ], FormFieldActions);
    return FormFieldActions;
}());
export { FormFieldActions };
//# sourceMappingURL=form-field.actions.js.map