import { IFormFieldState } from './forms/form-field.reducer';
import { IFileReplaceState } from './media/file-replace.reducer';
import { IFolderPagesState } from './media/folder-page.reducer';
import { IAssortmentCategoryTooltip } from './products/category-tooltip.reducer';
import { IAddEntityDialogState } from './add-entity-dialog.reducer';
import { IBaseDashboardState } from './base-dashboard.reducer';
import { IBaseEntityListState } from './base-entity-list.reducer';
import { IPagesState } from './base-entity-page.reducer';
import { IDialogState } from './dialog.reducer';
import { IErrorState } from './error.reducer';
import { IPendingChangesState } from './pending-changes.reducer';
import { IFieldFiltersState } from './field-filter.reducer';
import { IGridOptionsState } from './grid-option.reducer';
import { IHistoryState } from './history.reducer';
import { IListState } from './list.reducer';
import { ILoadingState } from './loading.reducer';
import { ILocaleState } from './locale.reducer';
import { INotificationState } from './notification.reducer';
import { ISearchState } from './search.reducer';
import { ITaskSetting } from './task.reducer';
import { ITabs } from './tabs.reducer';
import { ITreeState } from './tree.reducer';
import { IUploadState } from './upload.reducer';
import { IUserSetting } from './user-setting.reducer';
import { IPageEditsState } from './websites/page-edit.reducer';
import { IReferencesState } from './websites/block-references.reducer';
import { IDndState } from './dnd.reducer';
import { IChannelCountryState } from './settings/system/channel-country.reducer';
import { IChannelDomainNameState } from './settings/system/channel-domain-name.reducer';
import { IContentPublishState } from './content-publish.reducer';
import { IScreenSizesState } from './websites/screen-sizes.reducer';
import { IChannelState } from './websites/channel.reducer';
import { IMultiFieldState } from './multi-field.reducer';
import { IThumbnailGeneratorState } from './thumbnail-generator.reducer';
export declare class IAppState {
    products?: {
        assortmentsSearch?: ISearchState;
        filter?: {
            categoryTree?: ITreeState;
            categoryTreeDialog?: ITreeState;
            categoryTooltip?: IAssortmentCategoryTooltip;
        };
        productsSearch?: ISearchState;
        productlistsSearch?: ISearchState;
    };
    media?: {
        folder?: {
            sidebarTree?: ITreeState;
            uploadDialogTree?: ITreeState;
            fileSelectorFolderTree?: ITreeState;
        };
        fileReplace?: IFileReplaceState;
        upload?: IUploadState;
        dashboard?: IBaseDashboardState;
        folderPages?: IFolderPagesState;
        fileSelectorFolderPages?: IFolderPagesState;
        filePages?: IPagesState;
        quickSearch?: ISearchState;
        search?: ISearchState;
    };
    customers?: {
        dashboard?: IBaseDashboardState;
        pendingChanges?: IPendingChangesState;
        quickSearch?: ISearchState;
        groupPages?: IPagesState;
        groupsSearch?: ISearchState;
        organizationsSearch?: ISearchState;
        organizationPages?: IPagesState;
        personsSearch?: ISearchState;
        personRelationForm?: ISearchState;
        personPages?: IPagesState;
        targetGroup?: IBaseEntityListState;
        targetGroupPages?: IPagesState;
    };
    settings?: {
        menuTree?: ITreeState;
        addressType?: IBaseEntityListState;
        addressTypePages?: IPagesState;
        field?: IBaseEntityListState;
        fieldPages?: IPagesState;
        fieldTemplate?: IBaseEntityListState;
        fieldTemplatePages?: IPagesState;
        website?: IBaseEntityListState;
        websitePages?: IPagesState;
        blockCategory?: IBaseEntityListState;
        blockCategoryPages?: IPagesState;
        screen?: IBaseEntityListState;
        screenPages?: IPagesState;
        channelPages?: IPagesState;
        channel?: IBaseEntityListState;
        channelCountry?: IChannelCountryState;
        channelDomainName?: IChannelDomainNameState;
        taxClass?: IBaseEntityListState;
        taxClassPages?: IPagesState;
        market?: IBaseEntityListState;
        marketPages?: IPagesState;
        country?: IBaseEntityListState;
        countryPages?: IPagesState;
        language?: IBaseEntityListState;
        languagePages?: IPagesState;
        role?: IBaseEntityListState;
        rolePages?: IPagesState;
        domainName?: IBaseEntityListState;
        domainNamePages?: IPagesState;
        urlRedirectPages?: IPagesState;
        urlRedirectSearch?: ISearchState;
        websiteTextsPages?: IPagesState;
        websiteTextsSearch?: ISearchState;
        sales?: {
            deleteOldOrderPage?: IPagesState;
        };
    };
    sales?: {
        deliveryMethodSearch?: ISearchState;
        paymentMethodSearch?: ISearchState;
    };
    websites?: {
        dashboard?: IBaseDashboardState;
        pageEdit?: IPageEditsState;
        pageEditPendingChanges?: IPendingChangesState;
        blockQuickSearch?: ISearchState;
        blockReferences?: IReferencesState;
        blockProperties?: IPagesState;
        pagesSearch?: ISearchState;
        pagePages?: IPagesState;
        blocksSearch?: ISearchState;
        blockPages?: IPagesState;
        quickSearch?: ISearchState;
        websiteTree?: ITreeState;
        websiteTreeDropdown?: ITreeState;
        websiteTreeDialog?: ITreeState;
        screenSizes?: IScreenSizesState;
        channels?: IChannelState;
        pageThumbnailUpload?: IUploadState;
        blockThumbnailUpload?: IUploadState;
    };
    loading?: ILoadingState;
    error?: IErrorState;
    dialog?: IDialogState;
    notification?: INotificationState;
    addEntityDialog?: IAddEntityDialogState;
    formField?: IFormFieldState;
    locale?: ILocaleState;
    fieldFilter?: IFieldFiltersState;
    gridOptions?: IGridOptionsState;
    history?: IHistoryState;
    persisted?: any;
    task?: ITaskSetting;
    tabs: ITabs;
    userSetting?: IUserSetting;
    list?: IListState;
    contentPublish?: IContentPublishState;
    dnd?: IDndState;
    multiField?: IMultiFieldState;
    thumbnailGenerator?: IThumbnailGeneratorState;
}
export { IFormFieldState } from './forms/form-field.reducer';
export { IFileReplaceState } from './media/file-replace.reducer';
export { IFolderPagesState, IFolderState } from './media/folder-page.reducer';
export { IAssortmentCategoryTooltip, IAssortmentTooltip, IFirstCategoryTooltip, ICategoryTooltip } from './products/category-tooltip.reducer';
export { IAddEntityDialogState } from './add-entity-dialog.reducer';
export { IBaseDashboardState } from './base-dashboard.reducer';
export { IBaseEntityListState } from './base-entity-list.reducer';
export { IPagesState, IPageState } from './base-entity-page.reducer';
export { IDialogState } from './dialog.reducer';
export { IChanges, IPendingChangesState } from './pending-changes.reducer';
export { IContentPublishState } from './content-publish.reducer';
export { IErrorState, IError } from './error.reducer';
export { IFieldFiltersState, IFieldFilterState } from './field-filter.reducer';
export { IGridOptionsState, IGridOptionState } from './grid-option.reducer';
export { IHistoryState } from './history.reducer';
export { IListState, IListByKeyState } from './list.reducer';
export { ILoadingState } from './loading.reducer';
export { ILocaleState } from './locale.reducer';
export { INotificationState, INotificationItem } from './notification.reducer';
export { ISearchState, ISearchResultState } from './search.reducer';
export { ITaskSetting } from './task.reducer';
export { ITabs } from './tabs.reducer';
export { ITreeState } from './tree.reducer';
export { IUploadState, FileUploadStatus, FILE_UPLOAD_STATUS } from './upload.reducer';
export { IUserSetting } from './user-setting.reducer';
export { IPageEditsState, IPageEditState, IBlockContainer, IBlock } from './websites/page-edit.reducer';
export { IReferencesState, IReferenceState } from './websites/block-references.reducer';
export { IDndState } from './dnd.reducer';
export { IChannelCountryState } from './settings/system/channel-country.reducer';
export { IChannelDomainNameState } from './settings/system/channel-domain-name.reducer';
export { IScreenSize, IScreenSizesState } from './websites/screen-sizes.reducer';
export { IChannel, IChannelState } from './websites/channel.reducer';
export { IMultiFieldState, IMultiFieldModelState } from './multi-field.reducer';
export { IThumbnailGeneratorState, IThumbnailGenerator } from './thumbnail-generator.reducer';
