export interface IUploadState {
    files: any;
    orderedList: string[];
    queue: string[];
    changedFolder: string;
}
export declare class FileUploadStatus {
    id: string;
    systemId: string;
    index: number;
    name: string;
    parentFolderId: string;
    size: number;
    percent: number;
    status: number;
    message: string;
    blob: File;
    fullPath: string;
    overwrite: boolean;
    constructor(init?: Partial<FileUploadStatus>);
    static buildId(fileName: string, parentFolderId: string): string;
    static fromFile(file: any, parentFolderId: string, fileId?: string): FileUploadStatus;
    static fromFileList(files: any, parentFolderId: string): FileUploadStatus[];
}
export declare const FILE_UPLOAD_STATUS: {
    CONFLICT: number;
    UPLOADING: number;
    IDLE: number;
    ERROR: number;
    UPLOADED: number;
    CANCELLED: number;
};
