var FileUploadStatus = /** @class */ (function () {
    function FileUploadStatus(init) {
        this.overwrite = false;
        Object.assign(this, init);
    }
    FileUploadStatus.buildId = function (fileName, parentFolderId) {
        return parentFolderId + "." + fileName;
    };
    // Note: set file's type as any in order to be able to mock and test it
    FileUploadStatus.fromFile = function (file /*File*/, parentFolderId, fileId) {
        if (fileId === void 0) { fileId = ''; }
        return new FileUploadStatus({
            id: fileId ? fileId : FileUploadStatus.buildId(file.name, parentFolderId),
            parentFolderId: parentFolderId,
            name: file.name,
            size: file.size,
            percent: 0,
            status: FILE_UPLOAD_STATUS.IDLE,
            blob: file
        });
    };
    // Note: set files' type as any in order to be able to mock and test it
    FileUploadStatus.fromFileList = function (files /*FileList*/, parentFolderId) {
        // Note: FileList is not an array, we can't use FileList.map
        var list = [];
        for (var x = 0; x < files.length; x++) {
            list.push(FileUploadStatus.fromFile(files[x], parentFolderId));
        }
        return list;
    };
    return FileUploadStatus;
}());
export { FileUploadStatus };
export var FILE_UPLOAD_STATUS = {
    CONFLICT: -10,
    UPLOADING: 0,
    IDLE: 10,
    ERROR: 20,
    UPLOADED: 30,
    CANCELLED: 40
};
//# sourceMappingURL=upload.reducer.js.map