import { EventEmitter } from '@angular/core';
/**
 * Represents a queue runner service, which process item in queue.
 */
export declare abstract class QueueRunnerService<T> {
    onStart: EventEmitter<{}>;
    onProgress: EventEmitter<{}>;
    onComplete: EventEmitter<{}>;
    onError: EventEmitter<{}>;
    onAbort: EventEmitter<{}>;
    onConflict: EventEmitter<{}>;
    private _running;
    /**
     * Start the runner if it is stopped, resume if it is paused, and do nothing if it is running.
     */
    resume(): void;
    private _start;
    abstract readonly queue: T[];
    abstract run(item: T): any;
}
